<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:external="http://www.seapine.com" exclude-result-prefixes="external" id="TT V5.0 NonDetailReport.xslt">
	<xsl:output method="html" version="4.0" encoding="UTF-8" indent="yes"/>

   <xsl:include href="./Templates/EJSC_css.xslt"/>

   
   <!-- Parameters used by the server, DO NOT MODIFY -->
	<xsl:param name="ChartFileNames"/>
	<xsl:param name="Legend"/>
	<xsl:variable name="RecordsPerPage" select="SeapineReport/rows_per_page"/>
	<!-- Specifies the maximum number of charts that will appear on a single row in the html output -->
	<xsl:param name="MaxChartsPerLine" select="3"/>
	<!-- Specifies the background color to use for every other row in the report detail -->
	<xsl:param name="AlternateRowColor" select=" '#F5F5F5' "/>
	<!-- Contains the default settings for the table containing the page header -->
	<xsl:attribute-set name="report-pageheader-table-format">
		<xsl:attribute name="width">100%</xsl:attribute>
		<xsl:attribute name="border">0</xsl:attribute>
		<xsl:attribute name="cellpadding">0</xsl:attribute>
		<xsl:attribute name="cellspacing">0</xsl:attribute>
	</xsl:attribute-set>

	<!-- Contains the default settings for the table row containing the hide/show report/chart buttons -->
	<xsl:attribute-set name="report-pageheader-buttons-row-format">
		<xsl:attribute name="width">100%</xsl:attribute>
		<xsl:attribute name="border">0</xsl:attribute>
		<xsl:attribute name="cellpadding">10</xsl:attribute>
		<xsl:attribute name="cellspacing">0</xsl:attribute>
	</xsl:attribute-set>
   
   <xsl:attribute-set name="ejschart-js">
      <xsl:attribute name="src"><xsl:value-of select="external:get-server-image('EJSChart.js')" disable-output-escaping="yes"/></xsl:attribute>
      <xsl:attribute name="type">text/javascript</xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="excanvas-js">
      <xsl:attribute name="src"><xsl:value-of select="external:get-server-image('excanvas.js')" disable-output-escaping="yes"/></xsl:attribute>
      <xsl:attribute name="type">text/javascript</xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="browser-type-js">
      <xsl:attribute name="src"><xsl:value-of select="external:get-server-image('browser_type.js')" disable-output-escaping="yes"/></xsl:attribute>
      <xsl:attribute name="type">text/javascript</xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="multi-dropdown-js">
      <xsl:attribute name="src"><xsl:value-of select="external:get-server-image('mltidrpd.js')" disable-output-escaping="yes"/></xsl:attribute>
      <xsl:attribute name="type">text/javascript</xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="multi-dropdown-css">
      <xsl:attribute name="href"><xsl:value-of select="external:get-server-image('mltidrpd.css')" disable-output-escaping="yes"/></xsl:attribute>
      <xsl:attribute name="rel">stylesheet</xsl:attribute>
      <xsl:attribute name="type">text/css</xsl:attribute>
      <xsl:attribute name="media">screen,print</xsl:attribute>
   </xsl:attribute-set>
   
	<!-- Contains external image tag for the image in the page header -->
	<xsl:attribute-set name="report-pageheader-image">
		<xsl:attribute name="src"><xsl:value-of select="external:get-server-image('seapinelogo.jpg')" disable-output-escaping="yes"/></xsl:attribute>
	</xsl:attribute-set>

   <xsl:attribute-set name="report-join-image">
      <xsl:attribute name="src"><xsl:value-of select="external:get-server-image('join.gif')" disable-output-escaping="yes"/></xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="report-empty-image">
      <xsl:attribute name="src"><xsl:value-of select="external:get-server-image('empty.gif')" disable-output-escaping="yes"/></xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="report-plus-image">
      <xsl:attribute name="src">
         <xsl:value-of select="external:get-server-image('plus.gif')" disable-output-escaping="yes"/>
      </xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="report-plusbottom-image">
      <xsl:attribute name="src">
         <xsl:value-of select="external:get-server-image('plusbottom.gif')" disable-output-escaping="yes"/>
      </xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="report-joinbottom-image">
      <xsl:attribute name="src">
         <xsl:value-of select="external:get-server-image('joinbottom.gif')" disable-output-escaping="yes"/>
      </xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="report-line-image">
      <xsl:attribute name="src">
         <xsl:value-of select="external:get-server-image('line.gif')" disable-output-escaping="yes"/>
      </xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="report-minus-image">
      <xsl:attribute name="src">
         <xsl:value-of select="external:get-server-image('minus.gif')" disable-output-escaping="yes"/>
      </xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="report-minusbottom-image">
      <xsl:attribute name="src">
         <xsl:value-of select="external:get-server-image('minusbottom.gif')" disable-output-escaping="yes"/>
      </xsl:attribute>
   </xsl:attribute-set>

   <!-- Contains the default settings for table cell containing the image in the page header -->
	<xsl:attribute-set name="report-pageheader-image-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">ReportTitleClass</xsl:attribute>
	</xsl:attribute-set>
	<!-- Contains the default settings for the column heading table cells -->
	<xsl:attribute-set name="report-header-title-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">ReportTitleClass</xsl:attribute>
	</xsl:attribute-set>
	<!-- Contains the default settings for the reporting period in the page header-->
	<xsl:attribute-set name="report-header-reporting-date-format">
		<xsl:attribute name="align">center</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">SubtotalCellClass</xsl:attribute>
		<xsl:attribute name="colspan">2</xsl:attribute>
	</xsl:attribute-set>
	<!-- Contains the default settings for the report footer table -->
	<xsl:attribute-set name="report-pagefooter-table-format">
		<xsl:attribute name="width">100%</xsl:attribute>
		<xsl:attribute name="border">0</xsl:attribute>
		<xsl:attribute name="cellpadding">0</xsl:attribute>
		<xsl:attribute name="cellspacing">0</xsl:attribute>
      <xsl:attribute name="class">PageFooterClass</xsl:attribute>
	</xsl:attribute-set>
	<!-- Contains the default settings for the report detail table -->
	<xsl:variable name="detail-table-bordersize" select="0"/>
	<xsl:variable name="detail-table-width" select=" '100%' "/>
	<xsl:variable name="detail-table-cellpadding" select="5"/>
	<xsl:variable name="detail-table-cellspacing" select="0"/>
	<xsl:attribute-set name="report-detail-table-format">
		<xsl:attribute name="width"><xsl:value-of select="$detail-table-width" disable-output-escaping="yes"/></xsl:attribute>
		<xsl:attribute name="border"><xsl:value-of select="$detail-table-bordersize" disable-output-escaping="yes"/></xsl:attribute>
		<xsl:attribute name="cellpadding"><xsl:value-of select="$detail-table-cellpadding" disable-output-escaping="yes"/></xsl:attribute>
		<xsl:attribute name="cellspacing"><xsl:value-of select="$detail-table-cellspacing" disable-output-escaping="yes"/></xsl:attribute>
	</xsl:attribute-set>
	<!-- Contains the default settings for the column heading table cells -->
	<xsl:attribute-set name="report-column-heading-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">ColumnHeaderClass</xsl:attribute>
	</xsl:attribute-set>
	<!-- Contains the default settings for the row heading table cells -->
	<xsl:attribute-set name="report-row-heading-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">RowHeaderClass</xsl:attribute>
	</xsl:attribute-set>
	<!-- Contains the default settings for the data cells for the report detail table-->
	<xsl:attribute-set name="report-data-cell-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">DataCellClass</xsl:attribute>
	</xsl:attribute-set>
	<!-- Contains the default settings for the data cells for the report detail table-->
	<xsl:attribute-set name="report-subtotal-cell-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">SubtotalCellClass</xsl:attribute>
	</xsl:attribute-set>
	<xsl:attribute-set name="report-column-totals-row-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">ColumnTotalsClass</xsl:attribute>
      <xsl:attribute name="name">FooterRow</xsl:attribute>
	</xsl:attribute-set>
	<!-- Contains the default settings for the data cells for the report detail table-->
	<xsl:attribute-set name="report-pagefooter-cell-format">
		<xsl:attribute name="align">left</xsl:attribute>
		<xsl:attribute name="valign">middle</xsl:attribute>
		<xsl:attribute name="class">DataCellClass</xsl:attribute>
	</xsl:attribute-set>
   <xsl:attribute-set name="report-primarygroupingrow-format">
      <xsl:attribute name="align">left</xsl:attribute>
      <xsl:attribute name="bgcolor">#AEA3CF</xsl:attribute>
      <xsl:attribute name="valign">middle</xsl:attribute>
      <xsl:attribute name="class">GroupingRowClass</xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="report-primarygroupingrow-format-noborder">
      <xsl:attribute name="align">left</xsl:attribute>
      <xsl:attribute name="bgcolor">#AEA3CF</xsl:attribute>
      <xsl:attribute name="valign">middle</xsl:attribute>
      <xsl:attribute name="class">GroupingRowClassNoBorder</xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="report-secondarygroupingrow-format">
      <xsl:attribute name="align">left</xsl:attribute>
      <xsl:attribute name="bgcolor">#D8D7D7</xsl:attribute>
      <xsl:attribute name="valign">middle</xsl:attribute>
      <xsl:attribute name="class">SecGroupingRowClass</xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="report-secondarygroupingrow-format-noborder">
      <xsl:attribute name="align">left</xsl:attribute>
      <xsl:attribute name="bgcolor">#D8D7D7</xsl:attribute>
      <xsl:attribute name="valign">middle</xsl:attribute>
      <xsl:attribute name="class">SecGroupingRowClassNoBorder</xsl:attribute>
   </xsl:attribute-set>
   <xsl:attribute-set name="report-hiddenrow">
      <xsl:attribute name="style">display: none;</xsl:attribute>
   </xsl:attribute-set>

   <!-- Defines the default font settings used in the report -->
	<xsl:template name="DefineStyles">
		<!-- Default font settings for the image displayed in the left hand area of the Report Header -->
		<style>
		 		.ReportTitleGraphicClass 	{
					font-family: Arial, Helvetica, sans-serif;
					font-size: 30px;
					color: #000000;
					font-weight:bold;
				}
	      </style>
		<!-- Default font settings for the title of the report displayed in the right hand area of the Report Header -->
		<style>  
		 		.ReportTitleClass	{
					font-family: Arial, Helvetica, sans-serif;
					font-size: 30px;
					color: #000000;
					font-weight:bold;
				}
	      </style>
		<!-- Default font settings for the report detail Column Headings -->
		<style>
		 		.ColumnHeaderRowClass	{
					font-family: Arial, Helvetica, sans-serif;
					font-weight: bold;
					font-size: 14px;
					color: #FFFFFF;
               background-color: #6E99D4;
               padding-top: 7px;
               padding-bottom: 7px;
               margin-left: 5px;
				}
	      </style>
		<!-- Default font settings for the report detail Column Headings -->
		<style>
		 		.ColumnHeaderClass	{
					font-family: Arial, Helvetica, sans-serif;
					font-weight: bold;
					font-size: 14px;
					color: #FFFFFF;
               padding-top: 7px;
               padding-bottom: 7px;
               margin-left: 5px;
				}
	      </style>
		<!-- Default style for the footer -->
		<style>
		 		.FooterClass	{
					font-family: Arial, Helvetica, sans-serif;
					font-size: 14px;
					color: #000000;
               background-color: #FFFFFF;
               font-weight: normal;
               padding-top: 7px;
               padding-bottom: 2px;
               margin-left: 5px;
				}
	      </style>
		<!-- Style for the item count -->
		<style>
		 		.ItemCountClass	{
					font-family: Arial, Helvetica, sans-serif;
					font-size: 14px;
					color: #000000;
               background-color: #FFFFFF;
               font-weight: normal;
               padding-left: 10px;
				}
	      </style>
		<!-- Style for the first label -->
		<style>
		 		.FirstLabelClass	{
               padding-left: 10px;
				}
	      </style>
		<!-- Default font settings for the report detail Row Headings -->
		<style>  
		 		.RowHeaderClass	{
					font-family: Arial, Helvetica, sans-serif;
					font-weight: bold;
					font-size: 12px;
					color: black;
				}
	      </style>
		<!-- Default font settings for the report detail data cells -->
		<style>  
		 		.DataCellClass	{
					font-family: Arial, Helvetica, sans-serif;
					font-weight: ;
					font-size: 12px;
					color: black;
				}
	      </style>
		<!-- Default font settings for the report detail subtotal cells -->
		<style>  
		 		.SubtotalCellClass	{
					font-family: Arial, Helvetica, sans-serif;
					font-weight: bold ;
					font-size: 12px;
					color: black;
				}
	      </style>
		<!-- Default style for the primary grouping rows -->
		<style>
         .GroupingRowClass	{
            font-family: Arial, Helvetica, sans-serif;
            font-weight: bold ;
            font-size: 12px;
            color: black;
            border-bottom: 1px solid white;
            background-color: #C6D6EC;
         }
      </style>
		<!-- Style for the primary grouping rows that don't need a border-->
		<style>
         .GroupingRowClassNoBorder	{
            font-family: Arial, Helvetica, sans-serif;
            font-weight: bold ;
            font-size: 12px;
            color: black;
            background-color: #C6D6EC;
         }
      </style>
		<!-- Default style for the secondary grouping rows -->
		<style>
         .SecGroupingRowClass	{
            font-family: Arial, Helvetica, sans-serif;
            font-weight: bold ;
            font-size: 12px;
            color: black;
            background-color: #D8D7D7;
            border-bottom: 1px solid white;
         }
      </style>
		<!-- Style for the secondary grouping rows that don't need a border-->
		<style>
         .SecGroupingRowClassNoBorder	{
            font-family: Arial, Helvetica, sans-serif;
            font-weight: bold ;
            font-size: 12px;
            color: black;
            background-color: #D8D7D7;
         }
      </style>
      <!-- Default font settings for the report totals row -->
		<style>  
         .ColumnTotalsClass	{
            font-family: Arial, Helvetica, sans-serif;
            font-weight: bold;
            font-size: 14px;
            background-color: #6E99D4;
            color: #FFFFFF;
            padding-top: 7px;
            padding-bottom: 7px;
         }
      </style>
      <style>
         .CollapseAllButtonClass {
            margin-right: 10px;
         }
         .ExpandAllButtonClass {
         }
         .HideReportButtonClass {
         }
         .HideChartButtonClass {
            margin-left: 10px;
            margin-bottom: 1px;
         }
      </style>
      <style>
         .PageFooterClass {
            border-color: #FFFFFF;
            page-break-after: always;
         }
      </style>
      <!-- The following are used to format the chart and associated controls.  These are not used by the report portion. -->
      <style media="screen,print">
         .LabelClass {
            font-family: Helvetica, sans-serif;
            font-size: 10px; 
            position: absolute;
            padding: 2px;
            opacity: 0.8;
            filter: Alpha(opacity:80);
            background-color: #FFFFFF;
         }
         .chartToolbarLabelClass {
            font-family: Arial, Helvetica, sans-serif;
            font-weight: bold;
            font-size: 14px;
            color: #FFFFFF;
            padding-left: 5px;
            padding-right: 5px;
         }
         .chartToolbarFirstRowClass {
            padding-top: 7px;
            padding-bottom: 7px;
         }
         .iconsTd {
            width: 80px;
         }
         
         .spacerTd
         {
            width: 10px;
         }
         
         .iconsTd .containerTd {
            background-color: #FFFFFF;
            width: 20px;
            height: 20px;
            padding: 2px;
         }
         
         .iconsTd .containerTd img{
            text-decoration:none;
            float: none;
            opacity:1;
            background-repeat:no-repeat;
            border:0px;
            height:16px;
            width:16px;
            padding:0;
            line-height; 1;
            background-color: #FFFFFF;
         }
         
         .barImageEnabledContainer img {
            background-image:url(<xsl:value-of select="external:get-server-image('images.gif')" disable-output-escaping="yes"/>);
            background-position:-2px -374px;
         }
      
         .pieImageEnabledContainer img {
            background-image:url(<xsl:value-of select="external:get-server-image('images.gif')" disable-output-escaping="yes"/>);
            background-position:-2px -422px;
         }
      
         .barImageDisabledContainer img {
            background-image:url(<xsl:value-of select="external:get-server-image('images_d.gif')" disable-output-escaping="yes"/>);
            background-position:-2px -374px;
         }
      
         .pieImageDisabledContainer img {
            background-image:url(<xsl:value-of select="external:get-server-image('images_d.gif')" disable-output-escaping="yes"/>);
            background-position:-2px -422px;
         }
      
         .AxisLabelClass {
            left: 0px;
            padding: 0px 0px 0px 0px;
         }
         .AxisLabelHidden {
            visibility: hidden;
         }
         .AxisLabelVisible {
            visibility: visible;
         }
         .chartToolbarIcon {
         }
         .chartContainerDivClass {
            width: 800px;
            padding: 0px 0px 0px 0px;
            margin-left: 0px;
            margin-right: 0px;
            margin-bottom: 20px;
            background-color: #FFFFFF;
            border-left: 1px solid #6E99D4;
            border-right: 1px solid #6E99D4;
            border-bottom: 1px solid #6E99D4;
         }
         .chartToolbarDivClass {
            display: block;
            background-color: #6E99D4;
            width: 800px;
            padding: 0px 0px 0px 0px;
            margin: 0px 0px 0px 0px;
         }
         .chartToolbarTableClass {
            padding: 2px 2px 2px 2px;
            width: 796px;
         }
         .breadcrumbDivClass {
            font-family: Arial, Helvetica, sans-serif;
            font-size: 10px;
            display: block;
            background-color: #EBE9E9;
            width: 800px;
            padding-left: 0px;
            padding-right: 0px;
            padding-top: 2px;
            padding-bottom: 2px;
         }
         .breadCrumbTableClass {
            width: 796px;
         }
         .breadcrumbSpanClass {
            margin-right: 20px;
            font-size: 10px;
            padding-left: 9px;
         }
         .breadCrumbCurrentClass {
            font-weight: bold;
         }
         .chartTitleClass {
            display: block;
            padding: 2px 2px 2px 2px;
            text-align: center;
            font-family: Arial, Verdana, Helvetica, sans-serif;
            font-size: 14px;
            font-weight: bold;
         }
         
         .chartDivClass {
            margin-left: 5px;
            width: 790px;
            height: 600px;
         }
         .goUpButtonDisabled
         {
            background-image:url(<xsl:value-of select="external:get-server-image('moveup_d.png')" disable-output-escaping="yes"/>);
            background-repeat:no-repeat;
            background-position: center center;
            width: 28px;
         }
         .goUpButtonEnabled
         {
            background-image:url(<xsl:value-of select="external:get-server-image('moveup_e.png')" disable-output-escaping="yes"/>);
            background-repeat:no-repeat;
            background-position: center center;
            width: 28px;
         }
         body {
            background-color: #FFFFFF;
         }
      </style>
	</xsl:template>

   <!-- Get the index to the primary sort column-->
   <xsl:variable name="priSortColIdx" select="number(SeapineReport/Report/TableHeader/PrimarySortColumnIndex)"/>

   <!-- Get the index to the secondary sort column-->
   <xsl:variable name="secSortColIdx" select="number(SeapineReport/Report/TableHeader/SecondarySortColumnIndex)"/>
   
   <!-- This is the string to use when we need to label something as 'not set' -->
   <xsl:variable name="strNotSet">&amp;lt;not set&amp;gt;</xsl:variable>


      <!-- Overrides the field format for a cell from the XML data if the user overrode any of the stylesheet settings -->
	<xsl:template name="OverrideCellFormat">
		<xsl:if test="HAlign">
			<xsl:attribute name="align"><xsl:value-of select="HAlign" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="VAlign">
			<xsl:attribute name="valign"><xsl:value-of select="VAlign" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="Width">
			<xsl:attribute name="width"><xsl:value-of select="Width" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="Height">
			<xsl:attribute name="height"><xsl:value-of select="Height" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="BackgroundColor">
			<xsl:attribute name="bgcolor"><xsl:value-of select="BackgroundColor" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
	</xsl:template>
   
   <xsl:template name="NonBreakingSpace">
      <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
   </xsl:template>
   
	<!-- Displays the Column Heading Row of the Report Detail Table -->
	<xsl:template match="TableHeader">

      <!-- Column Headers -->
		<tr class="ColumnHeaderRowClass" id="ColumnHeaderRow">
			<xsl:if test="ColHeading">
            <xsl:if test="$priSortColIdx > 0">
               <xsl:for-each select="ColHeading[$priSortColIdx]">
                  <td xsl:use-attribute-sets="report-column-heading-format">
                     <xsl:attribute name="class">FirstColumnHeaderClass</xsl:attribute>
                     <xsl:call-template name="OverrideCellFormat"/>
                     <span style="color:{FontColor}; font-size:{FontSize}; font-weight:{FontWeight}; font-family:{FontFamily}; padding-left: 10px;">
                        <xsl:variable name="colLabel" select="Label"/>
                        <xsl:if test="string-length($colLabel)>0">
                           <xsl:value-of select="$colLabel" disable-output-escaping="yes"/>
                        </xsl:if>
                        <xsl:if test="string-length($colLabel)=0">
                           <xsl:call-template name="NonBreakingSpace"/>
                        </xsl:if>
                     </span>
                  </td>
               </xsl:for-each>
            </xsl:if>

            <xsl:if test="$secSortColIdx > 0">
               <xsl:for-each select="ColHeading[$secSortColIdx]">
                  <td xsl:use-attribute-sets="report-column-heading-format">
                     <xsl:call-template name="OverrideCellFormat"/>
                     <span style="color:{FontColor}; font-size:{FontSize}; font-weight:{FontWeight}; font-family:{FontFamily} ">
                     <xsl:variable name="colLabel" select="Label"/>
                        <xsl:if test="string-length($colLabel)>0">
                           <xsl:value-of select="$colLabel" disable-output-escaping="yes"/>
                        </xsl:if>
                        <xsl:if test="string-length($colLabel)=0">
                           <xsl:call-template name="NonBreakingSpace"/>
                        </xsl:if>
                     </span>
                  </td>
               </xsl:for-each>
            </xsl:if>
            
            <xsl:for-each select="ColHeading">
               <!-- Skip adding cell for first column in grouping row as we added this above -->
                  <xsl:if test="($priSortColIdx = 0) or (position()!=$priSortColIdx)">
                     <xsl:if test="($secSortColIdx = 0) or (position() != $secSortColIdx)">
                        <td xsl:use-attribute-sets="report-column-heading-format">
                           <xsl:if test="ancestor::SeapineReport/Report/DataRows/Row[@ID=1]">
                              <xsl:variable name="pos" select="position()"/>
                              <xsl:if test="ancestor::SeapineReport/Report/DataRows/Row[@ID=1]/Col[@ID=$pos]/DataType[@Sum='Yes']">
                                 <xsl:attribute name="align">right</xsl:attribute>
                              </xsl:if>
                           </xsl:if>
   						      <xsl:call-template name="OverrideCellFormat"/>
   						      <span style="color:{FontColor}; font-size:{FontSize}; font-weight:{FontWeight}; font-family:{FontFamily} ">
                              <xsl:if test="($priSortColIdx = 0) and (position() = 1)">
                                 <xsl:text disable-output-escaping="yes">&lt;span style=&quot;padding-left: 10px&quot;&gt;</xsl:text>
                              </xsl:if>
   							      <xsl:if test="string-length(Label)>0">
                                 <xsl:value-of select="Label" disable-output-escaping="yes"/>
   							      </xsl:if>
   							      <xsl:if test="string-length(Label)=0">
                                 <xsl:call-template name="NonBreakingSpace"/>
   							      </xsl:if>
                              <xsl:if test="($priSortColIdx = 0) and (position() = 1)">
                                 <xsl:text disable-output-escaping="yes">&lt;/span&gt;</xsl:text>
                              </xsl:if>
   						      </span>
   					      </td>
                     </xsl:if>
                  </xsl:if>
				</xsl:for-each>
			</xsl:if>
		</tr>
	</xsl:template>
   
   <!-- Writes a primary grouping row -->
   <xsl:template name="insertPrimaryGroupingRow">
      <xsl:param name="primaryRowID"/>

      <tr id="{$primaryRowID}" style="vertical-align: center;">
         <td xsl:use-attribute-sets="report-primarygroupingrow-format">
            <xsl:variable name="jsposition" select="position() - 1"/>
            <table cellspacing="0" cellpadding="0" border="0"><tr valign="middle"><td xsl:use-attribute-sets="report-primarygroupingrow-format" style="border: 0;">
               <xsl:choose>
                  <!-- If there is a secondary sort column set, then the primary groups will initially be expanded; otherwise they will be initially collapsed -->
                  <xsl:when test="$secSortColIdx > 0">
                     <img xsl:use-attribute-sets="report-minus-image" name="GroupingRowImage" align="left" onclick="ToggleGroupingRow({$jsposition}, true);" style="vertical-align: middle;"/>
                  </xsl:when>
                  <xsl:otherwise>
                     <img xsl:use-attribute-sets="report-plus-image" name="GroupingRowImage" align="left" onclick="ToggleGroupingRow({$jsposition}, false);" style="vertical-align: middle;"/>
                  </xsl:otherwise>
               </xsl:choose>
            </td><td xsl:use-attribute-sets="report-primarygroupingrow-format" style="border: 0;">
               <span onclick="ToggleGroupingRow({$jsposition}, gSecSortColIdx > 0);">
                  <xsl:choose>
                     <xsl:when test="string-length(Col[$priSortColIdx]/Data) = 0">
                        <xsl:value-of disable-output-escaping="yes" select="$strNotSet"/>
                     </xsl:when>
                     <xsl:otherwise>
                        <xsl:value-of select="Col[$priSortColIdx]/Data" disable-output-escaping="yes"/>
                     </xsl:otherwise>
                  </xsl:choose>
               </span>
            </td></tr></table>
         </td>
         <xsl:if test="$secSortColIdx>0">
            <td xsl:use-attribute-sets="report-primarygroupingrow-format">
               <xsl:call-template name="NonBreakingSpace"/>
            </td>
         </xsl:if>

         <xsl:for-each select="Col">
            <!-- Skip adding cell for first/second column in grouping row as we added this above -->
            <xsl:if test="(position() != $priSortColIdx) and (($secSortColIdx = 0) or (position() != $secSortColIdx))">
               <td xsl:use-attribute-sets="report-primarygroupingrow-format">
                  <xsl:if test="DataType[@Sum='Yes']">
                     <xsl:attribute name="align">right</xsl:attribute>
                  </xsl:if>
                  <!-- Summing the columns is done in javascript at load time to fix a floating point number display issue -->
                  <xsl:call-template name="NonBreakingSpace"/>
               </td>
            </xsl:if>
         </xsl:for-each>
      </tr>
   </xsl:template>
  
   <!-- Writes a secondary grouping row -->
   <xsl:template name="insertSecondaryGroupingRow">
      <xsl:variable name="jsposition" select="position()-1"/>
      <tr style="vertical-align: center;">
         <td class="DataCellClass">
            <xsl:call-template name="NonBreakingSpace"/>
         </td>
         <td xsl:use-attribute-sets="report-secondarygroupingrow-format">
            <table cellspacing="0" cellpadding="0" border="0"><tr valign="middle"><td xsl:use-attribute-sets="report-secondarygroupingrow-format" style="border: 0;">
               <img xsl:use-attribute-sets="report-plus-image" name="GroupingRowImage" align="left" onclick="ToggleGroupingRow({$jsposition}, false);"/>
            </td><td xsl:use-attribute-sets="report-secondarygroupingrow-format" style="border: 0;">
            <span onclick="ToggleGroupingRow({$jsposition}, false);">
               <xsl:choose>
                  <xsl:when test="string-length(Col[$secSortColIdx]/Data) = 0">
                     <xsl:value-of disable-output-escaping="yes" select="$strNotSet"/>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:value-of select="Col[$secSortColIdx]/Data" disable-output-escaping="yes"/>
                  </xsl:otherwise>
               </xsl:choose>
            </span>
            </td></tr></table>
         </td>
         
         <xsl:for-each select="Col">
            <xsl:if test="position()!=$secSortColIdx and position()!=$priSortColIdx">
               <td xsl:use-attribute-sets="report-secondarygroupingrow-format">
                  <xsl:if test="DataType[@Sum='Yes']">
                     <xsl:attribute name="align">right</xsl:attribute>
                  </xsl:if>
                  <!-- Summing is done in javascript at load time to fix a floating point number display issue -->
                  <xsl:call-template name="NonBreakingSpace"/>
               </td>
            </xsl:if>
         </xsl:for-each>
      </tr>
   </xsl:template>
   
   <xsl:template name="dataRowWithStyle">
      <xsl:param name="styleValue"/>
      <!-- Outputs a row for the table -->
      <tr style="{$styleValue}; vertical-align: center;">
         <xsl:apply-templates select="RowHeading"/>
         <xsl:apply-templates select="Col"/>
         <xsl:apply-templates select="Subtotal"/>
      </tr>
   </xsl:template>

   <!-- Displays the rows for Report Detail Table -->
	<xsl:template match="Row">
      <xsl:if test="not(external:should-abort())" >
         <xsl:value-of select="external:increment-current-element()" />

         <!-- Outputs a primary/secondary grouping detail row if necessary -->
         <xsl:choose>
            <xsl:when test="($priSortColIdx > 0) and ((position() = 1) or (Col[$priSortColIdx]/Data != preceding-sibling::Row[1]/Col[$priSortColIdx]/Data))">
               <xsl:choose>
                  <xsl:when test="position() = 1">
                     <xsl:call-template name="insertPrimaryGroupingRow">
                        <xsl:with-param name="primaryRowID" select="'FirstGroupingRow'"/>
                     </xsl:call-template>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:call-template name="insertPrimaryGroupingRow">
                        <xsl:with-param name="primaryRowID" select="''"/>
                     </xsl:call-template>
                  </xsl:otherwise>
               </xsl:choose>
               <xsl:if test="$secSortColIdx > 0">
                  <xsl:call-template name="insertSecondaryGroupingRow"/>
               </xsl:if>
            </xsl:when>
            <xsl:otherwise>
               <xsl:if test="($secSortColIdx > 0) and (Col[$secSortColIdx]/Data != preceding-sibling::Row[1]/Col[$secSortColIdx]/Data)">
                  <xsl:call-template name="insertSecondaryGroupingRow"/>
               </xsl:if>
            </xsl:otherwise>
         </xsl:choose>

         <!-- When we are grouping, data rows are initially hidden -->
         <xsl:choose>
            <xsl:when test="$priSortColIdx = 0">
               <xsl:call-template name="dataRowWithStyle">
                  <xsl:with-param name="styleValue" select="''"/>
               </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
               <xsl:call-template name="dataRowWithStyle">
                  <xsl:with-param name="styleValue" select="'display: none;'"/>
               </xsl:call-template>
            </xsl:otherwise>
         </xsl:choose>

      </xsl:if>
	</xsl:template>

   <!-- Outputs the data cells for the report detail table -->
   <xsl:template match="Col">
   
      <xsl:if test="position() = 1">
         <!-- If we have a primary sort column then this is now in the 1st column so display empty column -->
         <xsl:if test="$priSortColIdx > 0">
            <td class="DataCellClass">
               <xsl:call-template name="NonBreakingSpace"/>
            </td>
         </xsl:if>
         
         <!-- If we have a secondary sort column then this is now in the 2nd column so display empty column -->
         <xsl:if test="$secSortColIdx > 0">
            <td class="DataCellClass">
               <xsl:call-template name="NonBreakingSpace"/>
            </td>
         </xsl:if>
      </xsl:if>
 
      <!-- If we have a primary sort column that was displayed in the first column so skip it.  This also applies to the secondary sort column. -->
      <xsl:if test="(position() != $priSortColIdx) and (($secSortColIdx = 0) or (position() != $secSortColIdx))">
         <td xsl:use-attribute-sets="report-data-cell-format">
            <xsl:if test="DataType[@Sum='Yes']">
               <xsl:attribute name="align">right</xsl:attribute>
            </xsl:if>
            <xsl:call-template name="OverrideCellFormat"/>
            <span STYLE="color:{FontColor}; font-size:{FontSize}; font-weight:{FontWeight}; font-family:{FontFamily}; ">
               <xsl:if test="string-length(Data) > 0">
                  <xsl:value-of select="Data" disable-output-escaping="yes"/>
               </xsl:if>
               <xsl:if test="string-length(Data) = 0">
                  <xsl:call-template name="NonBreakingSpace"/>
               </xsl:if>
            </span>
         </td>
      </xsl:if>
   </xsl:template>
   
	<!-- Determines if a page break is needed -->
	<xsl:template name="CheckRecordPagination">
		<xsl:param name="Page"/>
		<xsl:param name="tabledef">table</xsl:param>
		<xsl:if test="($RecordsPerPage > 0) and (position() != last())">
			<xsl:if test="(position() mod $RecordsPerPage) = 0">
				<!-- End previous detail table -->
				<xsl:text disable-output-escaping="yes">&lt;/table&gt;</xsl:text>
				<!-- Output page break -->
				<DIV style="page-break-after:always"/>
				<!-- Output a new page header -->
				<xsl:call-template name="pageheader"/>
				<!-- start a new detail table -->
				<xsl:text disable-output-escaping="yes">&lt;table width="</xsl:text>
				<xsl:value-of select="$detail-table-width" disable-output-escaping="yes"/>
				<xsl:text disable-output-escaping="yes">" border="</xsl:text>
				<xsl:choose>
					<xsl:when test="ancestor::SeapineReport/Report/BorderSize">
						<xsl:value-of select="ancestor::SeapineReport/Report/BorderSize" disable-output-escaping="yes"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$detail-table-bordersize" disable-output-escaping="yes"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">" cellpadding="</xsl:text>
				<xsl:choose>
					<xsl:when test="ancestor::SeapineReport/Report/CellPadding">
						<xsl:value-of select="ancestor::SeapineReport/Report/CellPadding" disable-output-escaping="yes"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$detail-table-cellpadding" disable-output-escaping="yes"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">" cellspacing="</xsl:text>
				<xsl:choose>
					<xsl:when test="ancestor::SeapineReport/Report/CellSpacing">
						<xsl:value-of select="ancestor::SeapineReport/Report/CellSpacing" disable-output-escaping="yes"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$detail-table-cellspacing" disable-output-escaping="yes"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:if test="ancestor::SeapineReport/Report/TableBackgroundColor">
					<xsl:text disable-output-escaping="yes">" bgcolor="</xsl:text>
					<xsl:value-of select="ancestor::SeapineReport/Report/TableBackgroundColor" disable-output-escaping="yes"/>
				</xsl:if>
				<xsl:text disable-output-escaping="yes">" &gt;</xsl:text>
				<!-- Output the table's header row on the new page-->
				<xsl:apply-templates select="ancestor::SeapineReport/Report/TableHeader"/>
			</xsl:if>
		</xsl:if>
	</xsl:template>
   
	<!-- Outputs the row heading for the report detail table -->
	<xsl:template match="RowHeading">
		<td xsl:use-attribute-sets="report-row-heading-format">         
			<xsl:call-template name="OverrideCellFormat"/>
         <span style="color:{FontColor}; font-size:{FontSize}; font-weight:{FontWeight}; font-family:{FontFamily}; ">
				<xsl:if test="string-length(Label)>0">
					<xsl:value-of select="Label" disable-output-escaping="yes"/>
				</xsl:if>
				<xsl:if test="string-length(Label)=0">
					<xsl:call-template name="NonBreakingSpace"/>
				</xsl:if>
			</span>
		</td>
	</xsl:template>
     
	<!--Outputs the Subtotals cell for the report detail table -->
	<xsl:template match="Subtotal">
		<td xsl:use-attribute-sets="report-subtotal-cell-format">
			<xsl:call-template name="OverrideCellFormat"/>
			<span style="color:{FontColor}; font-size:{FontSize}; font-weight:{FontWeight}; font-family:{FontFamily}; ">
				<xsl:if test="string-length(Data)>0">
					<xsl:value-of select="Data" disable-output-escaping="yes"/>
				</xsl:if>
				<xsl:if test="string-length(Data)=0">
					<xsl:call-template name="NonBreakingSpace"/>
				</xsl:if>
			</span>
		</td>
	</xsl:template>
   
	<!-- Outputs the Column Totals row for the list report table -->
	<xsl:template name="Totals">
      <!-- Write totals row -->
      <tr xsl:use-attribute-sets="report-column-totals-row-format" id="FooterTotalsRow">
         <xsl:call-template name="OverrideCellFormat"/>
         <xsl:if test="$priSortColIdx > 0">
            <td class="ColumnTotalsClass">
               <xsl:choose>
                  <xsl:when test="ancestor::SeapineReport/Report/DataRows/Row[@ID=1]/Col/DataType[@Sum='Yes']">
                     <span class="FirstLabelClass" id="FirstLabelSpan">
                        Total
                     </span>
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:call-template name="NonBreakingSpace"/>
                  </xsl:otherwise>
               </xsl:choose>
            </td>
            <xsl:if test="$secSortColIdx > 0">
               <td>
                  <xsl:call-template name="NonBreakingSpace"/>
               </td>
            </xsl:if>
         </xsl:if>
         
         <!-- Skip primary & secondary as necessary -->
         <xsl:for-each select="ancestor::SeapineReport/Report/DataRows/Row[@ID=1]/Col">
            <xsl:if test="($priSortColIdx = 0 or position() != $priSortColIdx) and ($secSortColIdx = 0 or position() != $secSortColIdx)">
               <!-- Skip adding cell for first/second column in grouping row as we added this above -->
               <td class="ColumnTotalsClass">
                  <xsl:if test="($priSortColIdx = 0) and (position() = 0)">
                     <xsl:text disable-output-escaping="yes">Total </xsl:text>
                  </xsl:if>
                  <xsl:choose>
                     <xsl:when test="DataType/@Sum = 'Yes'">
                        <xsl:attribute name="align">right</xsl:attribute>
                        <xsl:variable name="colIdx" select="number(position())"/>
                        <xsl:variable name="colsToSum" select="ancestor::SeapineReport/Report/DataRows/Row/Col[(@ID=$colIdx) and (Data != '')]/Data"/>
                        <xsl:choose>
                           <xsl:when test="count($colsToSum)=0">
                              <xsl:call-template name="NonBreakingSpace"/>
                           </xsl:when>
                           <xsl:otherwise>
                              <xsl:choose>
                                 <xsl:when test="DataType='Integer'">
                                    <xsl:value-of select="number(sum($colsToSum))"/>
                                 </xsl:when>
                                 <xsl:otherwise>
                                    <xsl:value-of select="format-number(number(sum($colsToSum)), '#.00')"/>
                                 </xsl:otherwise>
                              </xsl:choose>
                           </xsl:otherwise>
                        </xsl:choose>
                     </xsl:when>
                     <xsl:otherwise>
                        <xsl:call-template name="NonBreakingSpace"/>
                     </xsl:otherwise>
                  </xsl:choose>
               </td>
            </xsl:if>
         </xsl:for-each>
      </tr>
      <!-- Write Item Count Row -->
      <tr xsl:use-attribute-sets="report-column-heading-format">
         <xsl:if test="ancestor::SeapineReport/Report/TableHeader/ColHeading">
            <xsl:variable name="colspan" select="count(ancestor::SeapineReport/Report/TableHeader/ColHeading)"/>
            <xsl:variable name="itemCount" select="count(ancestor::SeapineReport/Report/DataRows/Row)"/>
            <td colspan="{$colspan}" class="FooterClass">
               <span class="ItemCountClass">
                  <xsl:choose>
                     <xsl:when test="$itemCount = 1">
                        1 item
                     </xsl:when>
                     <xsl:otherwise>
                        <xsl:value-of select="$itemCount"/> items
                     </xsl:otherwise>
                  </xsl:choose>
               </span>
            </td>
         </xsl:if>
      </tr>
      
	</xsl:template>
   
	<!-- Overrides the format for the report detail table from the XML data if the user overrode any of the stylesheet settings -->
	<xsl:template name="OverRideDetailTableFormat">
		<xsl:if test="Report/BorderSize">
			<xsl:attribute name="border"><xsl:value-of select="Report/BorderSize" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="Report/CellPadding">
			<xsl:attribute name="cellpadding"><xsl:value-of select="Report/CellPadding" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="Report/CellSpacing">
			<xsl:attribute name="cellspacing"><xsl:value-of select="Report/CellSpacing" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="Report/TableBackgroundColor">
			<xsl:attribute name="bgcolor"><xsl:value-of select="Report/TableBackgroundColor" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
	</xsl:template>
   
	<!-- Outputs the Report Detail Table -->
	<xsl:template name="createtable">
		<table id="ListReportDataTable" xsl:use-attribute-sets="report-detail-table-format">
			<xsl:call-template name="OverRideDetailTableFormat"/>
			<xsl:call-template name="processreport"/>
		</table>
	</xsl:template>
   
	<!-- Overrides the format for the report header table from the XML data if the user overrode any of the stylesheet settings -->
	<xsl:template name="OverRideReportHeaderTableFormat">
		<xsl:if test="ancestor-or-self::SeapineReport/ReportHeader/BorderSize">
			<xsl:attribute name="border"><xsl:value-of select="ancestor-or-self::SeapineReport/ReportHeader/BorderSize" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="ancestor-or-self::SeapineReport/ReportHeader/CellPadding">
			<xsl:attribute name="cellpadding"><xsl:value-of select="ancestor-or-self::SeapineReport/ReportHeader/CellPadding" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="ancestor-or-self::SeapineReport/ReportHeader/CellSpacing">
			<xsl:attribute name="cellspacing"><xsl:value-of select="ancestor-or-self::SeapineReport/ReportHeader/CellSpacing" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="ancestor-or-self::SeapineReport/ReportHeader/TableBackgroundColor">
			<xsl:attribute name="bgcolor"><xsl:value-of select="ancestor-or-self::SeapineReport/ReportHeader/TableBackgroundColor" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
	</xsl:template>
   
   <xsl:template name="ButtonsRow">
      <xsl:param name="id"/>
		<table id="{$id}" xsl:use-attribute-sets="report-pageheader-buttons-row-format">
			<xsl:call-template name="OverRideReportHeaderTableFormat"/>
         <tr>
            <!-- Show/Hide Report/Chart -->
            <td align="left">
               <xsl:if test="ancestor-or-self::SeapineReport/Report/TableHeader/ColHeading">
                  <input class="HideReportButtonClass" type="button" value="Hide Report" onclick="ToggleReportVisibility('btnHideReport');" name="btnHideReport"/>
               </xsl:if>
               <xsl:if test="$priSortColIdx > 0">
                  <input class="HideChartButtonClass" type="button" value="Hide Chart" onclick="ToggleChartVisibility('btnHideChart');" name="btnHideChart"/>
               </xsl:if>
            </td>
            <!-- Expand all / collapse all -->
            <td align="right">
               <xsl:choose>
                  <xsl:when test="$priSortColIdx > 0">
                     <input class="CollapseAllButtonClass" type="button" value="Collapse All" name="btnCollapseAll" onclick="SetAll(true)" />
                     <input class="ExpandAllButtonClass" type="button" value="Expand All" name="btnExpandAll" onclick="SetAll(false)" />
                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:call-template name="NonBreakingSpace"/>
                  </xsl:otherwise>
               </xsl:choose>
            </td>
         </tr>
      </table>
   </xsl:template>
   
	<!-- Outputs the Report Header -->
	<xsl:template name="pageheader">
		<table xsl:use-attribute-sets="report-pageheader-table-format">
			<xsl:call-template name="OverRideReportHeaderTableFormat"/>
			<tr>
				<td xsl:use-attribute-sets="report-header-title-format" align="left">
					<xsl:for-each select="ancestor-or-self::SeapineReport/ReportHeader">
						<xsl:call-template name="OverrideCellFormat"/>
					</xsl:for-each>
					<img xsl:use-attribute-sets="report-pageheader-image" align="absmiddle"/>
					<xsl:for-each select="ancestor-or-self::SeapineReport/ReportHeader">
						<xsl:call-template name="OverrideCellFormat"/>
					</xsl:for-each>
					<span style="color:{ancestor-or-self::SeapineReport/ReportHeader/FontColor}; font-size:{ancestor-or-self::SeapineReport/ReportHeader/FontSize}; font-weight:{ancestor-or-self::SeapineReport/ReportHeader/FontWeight}; font-family:{ancestor-or-self::SeapineReport/ReportHeader/FontFamily};">
						<xsl:apply-templates select="ancestor-or-self::SeapineReport/Title"/>
					</span>
				</td>
			</tr>
			<xsl:if test="ancestor-or-self::SeapineReport/report_period">
				<!-- include report period for distribution reports -->
				<tr>
					<td xsl:use-attribute-sets="report-header-reporting-date-format">
						<xsl:text>Report Period: </xsl:text>
						<xsl:value-of select="ancestor-or-self::SeapineReport/report_period" disable-output-escaping="yes"/>
					</td>
				</tr>
			</xsl:if>
		</table>
	</xsl:template>
   
	<!-- Overrides the format for the report footer table from the XML data if the user overrode any of the stylesheet settings -->
	<xsl:template name="OverRideReportFooterTableFormat">
		<xsl:if test="ReportFooter/BorderSize">
			<xsl:attribute name="border"><xsl:value-of select="ReportFooter/BorderSize" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="ReportFooter/CellPadding">
			<xsl:attribute name="cellpadding"><xsl:value-of select="ReportFooter/CellPadding" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="ReportFooter/CellSpacing">
			<xsl:attribute name="cellspacing"><xsl:value-of select="ReportFooter/CellSpacing" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="ReportFooter/TableBackgroundColor">
			<xsl:attribute name="bgcolor"><xsl:value-of select="ReportFooter/TableBackgroundColor" disable-output-escaping="yes"/></xsl:attribute>
		</xsl:if>
	</xsl:template>
   
	<!-- processes the page footer -->
	<xsl:template name="pagefooter">
		<table xsl:use-attribute-sets="report-pagefooter-table-format">
			<xsl:call-template name="OverRideReportFooterTableFormat"/>
			<tr>
				<td xsl:use-attribute-sets="report-pagefooter-cell-format">
               <xsl:call-template name="NonBreakingSpace"/>
            </td>
         </tr>
			<tr>
				<td xsl:use-attribute-sets="report-pagefooter-cell-format">
					<xsl:if test="ReportFooter">
						<xsl:for-each select="ReportFooter">
							<xsl:call-template name="OverrideCellFormat"/>
						</xsl:for-each>
					</xsl:if>
					<span style="color:{ReportFooter/FontColor}; font-size:{ReportFooter/FontSize}; font-weight:{ReportFooter/FontWeight}; font-family:{ReportFooter/FontFamily} ">
						<!-- place desired footer data here -->
					</span>
				</td>
			</tr>
		</table>
	</xsl:template>
   
	<!-- processes the report contents -->
	<xsl:template name="processreport">
		<xsl:if test="position()=1">
			<xsl:text disable-output-escaping="yes">&lt;tbody&gt;</xsl:text>
		</xsl:if>
		<xsl:if test="Report">
			<xsl:for-each select="Report">
				<xsl:apply-templates select="TableHeader"/>
            <xsl:value-of select="external:set-total-elements(count(//Row))" />
            <xsl:apply-templates select="DataRows"/>         
				<xsl:call-template name="Totals"/>
            <xsl:call-template name="ButtonsRow">
               <xsl:with-param name="id" select="'footerButtons'"/>
            </xsl:call-template>
			</xsl:for-each>
		</xsl:if>
		<xsl:if test="position()=last()">
			<xsl:text disable-output-escaping="yes">&lt;/tbody&gt;</xsl:text>
		</xsl:if>
	</xsl:template>
   
	<!-- Creates the html for a single chart image tag-->
	<xsl:template name="createchartimgtag">
		<xsl:param name="filenamestr"/>
		<xsl:param name="imageno"/>
		<xsl:param name="legendstr"/>
		<xsl:if test="string-length($filenamestr) > 0">
			<!-- get the image name from the string up to the semicolon or end of string -->
			<xsl:variable name="imagename" select="substring-before($filenamestr, ';')"/>
			<xsl:variable name="chartlegend" select="substring-before($legendstr, '1m9v^45rd1')"/>
			<!-- output the html -->
			<td align="center" valign="top">
				<img>
					<xsl:attribute name="src"><xsl:if test="contains($filenamestr,';') = false"><xsl:value-of select="$filenamestr" disable-output-escaping="yes"/></xsl:if><xsl:value-of select="$imagename" disable-output-escaping="yes"/></xsl:attribute>
				</img>
			</td>
			<!-- Determine if we need to build a legend for this chart -->
			<xsl:if test="string-length($legendstr) > 0">
				<td>
					<table border="2" cellpadding="1" cellspacing="2" bgcolor="white" width="100%">
						<xsl:call-template name="createlegendtag">
							<xsl:with-param name="legendstr" select="$chartlegend"/>
						</xsl:call-template>
					</table>
				</td>
			</xsl:if>
			<!-- check if we need to move to a new line -->
			<xsl:if test="$imageno mod $MaxChartsPerLine = 0">
				<xsl:text disable-output-escaping="yes">&lt;/tr&gt;&lt;tr&gt;</xsl:text>
			</xsl:if>
			<!-- look for the next occurrence of image name in string -->
			<xsl:call-template name="createchartimgtag">
				<xsl:with-param name="filenamestr" select="substring-after($filenamestr, ';')"/>
				<xsl:with-param name="imageno" select="$imageno+1"/>
				<xsl:with-param name="legendstr" select="substring-after($legendstr, '1m9v^45rd1')"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
   
	<!-- create the html for a single legend tag-->
	<xsl:template name="createlegendtag">
		<xsl:param name="legendstr"/>
		<xsl:if test="string-length($legendstr) > 0">
			<!-- get the image name from the string up to the semicolon or end of string -->
			<xsl:variable name="pair" select="substring-before($legendstr, '1m9v^45rd3')"/>
			<xsl:variable name="labelstr" select="substring-before($pair, '1m9v^45rd2')"/>
			<xsl:variable name="colorstr" select="substring-after($pair, '1m9v^45rd2')"/>
			<!-- output the html -->
			<tr>
				<td align="center" style="font-size:smaller" valign="top">
					<xsl:value-of select="$labelstr" disable-output-escaping="yes"/>
				</td>
				<td width="40px">
					<xsl:attribute name="bgColor"><xsl:value-of select="$colorstr" disable-output-escaping="yes"/></xsl:attribute>
				</td>
			</tr>
			<!-- look for the next occurrence of image name in string -->
			<xsl:call-template name="createlegendtag">
				<xsl:with-param name="legendstr" select="substring-after($legendstr, '1m9v^45rd3')"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
   
	<!-- Parses out the names of the chart graphic files from the ChartFileNames variable and creates the image tags-->
	<xsl:template name="createcharts">
		<xsl:if test="string-length($ChartFileNames) > 0">
			<table border="0" cellpadding="0" cellspacing="0" bgcolor="white">
				<tr>
					<th height="20"/>
				</tr>
				<tr>
					<xsl:call-template name="createchartimgtag">
						<xsl:with-param name="filenamestr" select="$ChartFileNames"/>
						<xsl:with-param name="imageno" select="1"/>
						<xsl:with-param name="legendstr" select="$Legend"/>
					</xsl:call-template>
				</tr>
			</table>
		</xsl:if>
	</xsl:template>
   
   <!-- Writes a javascript array that represents the grouping structure -->
   <xsl:template name="write-javascript-grouping-array"> 
      <xsl:if test="$priSortColIdx > 0">
         <xsl:choose>
            <xsl:when test="(position() = 1) or (Col[$priSortColIdx]/Data != preceding-sibling::Row[1]/Col[$priSortColIdx]/Data)">
               <xsl:text disable-output-escaping="yes">
               gGroupingIdxs.push(</xsl:text>
               <xsl:value-of select="position()-1"/>
               <xsl:text disable-output-escaping="yes">);</xsl:text>
               <xsl:if test="$secSortColIdx > 0">
                  <xsl:text disable-output-escaping="yes">
                  gGroupingIdxs.push(</xsl:text>
                  <xsl:value-of select="position()-1"/>
                  <xsl:text disable-output-escaping="yes">);</xsl:text>
               </xsl:if>
            </xsl:when>
            <xsl:otherwise>
               <xsl:if test="($secSortColIdx > 0) and (Col[$secSortColIdx]/Data != preceding-sibling::Row[1]/Col[$secSortColIdx]/Data)">
                  <xsl:text disable-output-escaping="yes">
                  gGroupingIdxs.push(</xsl:text>
                  <xsl:value-of select="position()-1"/>
                  <xsl:text disable-output-escaping="yes">);</xsl:text>
               </xsl:if>
            </xsl:otherwise>
         </xsl:choose>
      </xsl:if>
   </xsl:template>

   <xsl:template name="write-javascript-columns-array">
      <xsl:if test="DataType/@Sum = 'Yes'">
         <xsl:text disable-output-escaping="yes">
         gSummableCols.push([</xsl:text>
         <xsl:value-of select="position()"/>
         <!-- The label gets set in javascript to avoid errors associated with quotes in the column label -->
         <xsl:text disable-output-escaping="yes">, ""]);</xsl:text>
      </xsl:if>
   </xsl:template>
     
	<!-- SeapineReport XML Parsing -->
	<xsl:template match="/">
		<html>
			<head>
				<xsl:call-template name="DefineStyles"/>
         <link xsl:use-attribute-sets="multi-dropdown-css" />
         <style type="text/css" media="screen,print">
            <xsl:call-template name="write-ejsc-css"/>
         </style>
         
         <script xsl:use-attribute-sets="ejschart-js"></script>
         <script xsl:use-attribute-sets="excanvas-js"></script>
         <script xsl:use-attribute-sets="browser-type-js"></script>
         <script xsl:use-attribute-sets="multi-dropdown-js"></script>


         <script type="text/javascript">
            <![CDATA[
            
            //when collapsing or expanding a grouping row, what do we set the element.style.display to?
            function GetNewDisplay(bCollapsing)
            {
               if(bCollapsing)
                  return "none";
               else if(document.all)
                  return "block";   //IE4+ specific code
               else
                  return "table-row";  //Netscape/Mozilla
            }

            //sets the plus/minus image for a grouping row
            //row should be a table row element
            function SetRowImage(row, bCollapsing)
            {
               var rowImages = row.getElementsByTagName("img");
               for(var i = 0; i < rowImages.length; ++i)
               {
                  if(rowImages[i] && rowImages[i].name == "GroupingRowImage")
                  {
                     rowImages[i].src = bCollapsing ? kCollapsedImageSrc : kExpandedImageSrc;
                  }
               }
            }
            
            //NOTE: This takes an index to the array gGroupingIdxs
            function HasChildGroup(idxTo_gGroupingIdxs)
            {
               return idxTo_gGroupingIdxs >= 0 && idxTo_gGroupingIdxs + 1 < gGroupingIdxs.length && 
                  gGroupingIdxs[idxTo_gGroupingIdxs] == gGroupingIdxs[idxTo_gGroupingIdxs + 1];
            }
            
            // Finds idx in gGroupingIdxs
            // The intended use is to take idx, a fake row index as printed by the xslt, and return the corresponding position of this row in gGroupingIdxs
            function GetGroupingIndex(idx, bPrimary)
            {
               var left = 0, right = gGroupingIdxs.length - 1;
               while(left <= right)
               {
                  var i = Math.floor(left + (right - left) / 2);
                  if(gGroupingIdxs[i] == idx)
                  {
                     // We have to handle the fact that adjacent primary and secondary groups can have identical indices
                     if(!bPrimary && HasChildGroup(i))
                        ++i;
                     else if(bPrimary && !HasChildGroup(i))
                        --i;
                     if(i > gGroupingIdxs.length || gGroupingIdxs[i] != idx || bPrimary != HasChildGroup(i))
                        i = -1;
                     return i;
                  }
                  else if(gGroupingIdxs[i] > idx)
                     right = i - 1;
                  else
                     left = i + 1;
               }
               return -1;
            }
            
            //NOTE: This takes an index of the data row (ie. the position of the row if this were a non-grouping list report)
            //Returns the index of the row in gRows
            function GetRowsIndex(dataRowIdx)
            {
               // Find the minimum i for which gGroupingIdxs[i] > dataRowIdx
               var left = 0, right = gGroupingIdxs.length - 1;
               while(left <= right)
               {
                  var i = Math.floor(left + (right - left) / 2);
                  if(gGroupingIdxs[i] >= dataRowIdx)
                     right = i - 1;
                  else
                     left = i + 1;
               }
               for(var i = Math.max(0, Math.min(left, right)); i < gGroupingIdxs.length; ++i)
               {
                  if(gGroupingIdxs[i] > dataRowIdx)
                     return dataRowIdx + i;
               }
               return -1;
            }
            
            // On each primary group, calls doIt(groupingIdx, groupRowsIdx, childGroupRows, descendantDataRows) and collects the return values in an array
            function ForEachPrimary(doIt)
            {
               var returnVals = null;
               if(gGroupingIdxs.length > 0)
               {
                  returnVals = new Array();
                  if(HasChildGroup(0))
                  {  // secondary groups exist
                     var currentGroupIdx = 0;
                     while(currentGroupIdx + 1 < gGroupingIdxs.length)
                     {
                        // Find next primary group start (or end)
                        var childGroupRows = new Array();
                        var descendantDataRows = new Array();
                        var idx = currentGroupIdx + 1;
                        while(idx + 1 < gGroupingIdxs.length && !HasChildGroup(idx))
                        {
                           var dataRowIdx = GetRowsIndex(gGroupingIdxs[idx])
                           var childRowCount = gGroupingIdxs[idx + 1] - gGroupingIdxs[idx];
                           childGroupRows.push([dataRowIdx - 1, childRowCount]);
                           for(var i = 0; i < childRowCount; ++i)
                              descendantDataRows.push(dataRowIdx + i);
                           ++idx;
                        }
                        
                        returnVals.push(doIt(currentGroupIdx, GetRowsIndex(gGroupingIdxs[currentGroupIdx]) - 2, childGroupRows, descendantDataRows));
                        
                        //update currentGroupIdx
                        currentGroupIdx = idx;
                     }
                  }
                  else
                  {  // no secondary groups
                     for(var i = 0; i + 1 < gGroupingIdxs.length; ++i)
                     {
                        var childCount = gGroupingIdxs[i+1] - gGroupingIdxs[i];
                        var firstDataRowIdx = GetRowsIndex(gGroupingIdxs[i]);
                        var descendantDataRows = new Array();
                        for(var j = 0; j < childCount; ++j)
                           descendantDataRows.push(firstDataRowIdx + j);
                        
                        returnVals.push(doIt(i, firstDataRowIdx - 1, new Array(), descendantDataRows));
                     }
                  }
               }
               return returnVals;
            }

            // On each secondary group, calls doIt(groupingIdx, groupRowIdx, childDataRowCount) and collects the return values in an array
            function ForEachSecondary(parentPrimaryGroupIdx /*index to gGroupingIdxs*/, doIt)
            {
               var returnVals = null;
               if(gGroupingIdxs.length > 0)
               {
                  returnVals = new Array();
                  if(HasChildGroup(parentPrimaryGroupIdx))
                  {  // we got a valid primary group index
                     for(var currentGroupIdx = parentPrimaryGroupIdx + 1; 
                             currentGroupIdx + 1 < gGroupingIdxs.length && !HasChildGroup(currentGroupIdx); 
                             ++currentGroupIdx)
                     {
                        var childDataRowCount = gGroupingIdxs[currentGroupIdx + 1] - gGroupingIdxs[currentGroupIdx];
                        var groupRowIdx = GetRowsIndex(gGroupingIdxs[currentGroupIdx]) - 1;
                        
                        returnVals.push(doIt(currentGroupIdx, groupRowIdx, childDataRowCount));
                     }
                  }
               }
               return returnVals;
            }

            //called when a plus or minus is clicked
            // idx is the data row index (ie. Row/@ID from xml)
            //bPrimary is whether or not this is a primary group - this is used to distinguish between grouping rows when primary & secondary share the same index (ie. idx=0 will be both primary and secondary)
            function ToggleGroupingRow(idx, bPrimary)
            {
               var groupingIdx = GetGroupingIndex(idx, bPrimary);
               if(groupingIdx != -1 && groupingIdx + 1 < gGroupingIdxs.length)
               {
                  if(bPrimary && HasChildGroup(0))
                  {
                     //this is a primary group with child secondary groups
                     var rowIdx = GetRowsIndex(gGroupingIdxs[groupingIdx]) - 2;
                     if(rowIdx >= 0)
                     {
                        var bCollapsing = gRows[rowIdx + 1].style.display != "none";
                        var newDisplay = GetNewDisplay(bCollapsing);
                        SetRowImage(gRows[rowIdx], bCollapsing);
                        ++rowIdx;
                        while(!HasChildGroup(++groupingIdx) && groupingIdx + 1 < gGroupingIdxs.length)
                        {
                           gRows[rowIdx].style.display = newDisplay;
                           var childRowCount = gGroupingIdxs[groupingIdx + 1] - gGroupingIdxs[groupingIdx];
                           if(bCollapsing)
                           {
                              SetRowImage(gRows[rowIdx], bCollapsing);
                              ++rowIdx;
                              for(var i = 0; i < childRowCount; ++i)
                                 gRows[rowIdx++].style.display = newDisplay;
                           }
                           else
                              rowIdx += 1 + childRowCount;
                        }
                     }
                  }
                  else
                  {  //Either this is a secondary grouping row, or it is a primary grouping row but no secondary sort col is set
                     var dataRowIdx = GetRowsIndex(gGroupingIdxs[groupingIdx]);
                     if(dataRowIdx > 0)
                     {
                        var bCollapsing = gRows[dataRowIdx].style.display != "none";
                        var newDisplay = GetNewDisplay(bCollapsing);
                        var childRowCount = gGroupingIdxs[groupingIdx + 1] - gGroupingIdxs[groupingIdx];
                        SetRowImage(gRows[dataRowIdx-1], bCollapsing);
                        for(var i = 0; i < childRowCount; ++i, ++dataRowIdx)
                           gRows[dataRowIdx].style.display = GetNewDisplay(bCollapsing);
                     }
                  }
               }
            }
            
            //generates the text that shows up when the user clicks the 'Show Labels' button
            function GenerateLabelForPoint(series, point)
            {
               var strLabel = "";
               if(gChartType == kChartType_Bar)
               {
                  strLabel += "<strong>" + series.title + "</strong> ";
                  strLabel += point.x;
                     
               }
               else if(gChartType == kChartType_Pie)
               {
                  if(point.x > 0)
                  {
                     strLabel += "<strong>" + series.title + "</strong><br />";
                     if(CanDrilldown(gZoomLevel))
                        strLabel += "<strong>" + point.label + "</strong><br />";
                     strLabel += point.x + " (" + FormatToPrecision(point.x / series.getTotalValue() * 100, 0) + "%)";
                  }
               }
               return strLabel;
            }
            
            function ToggleLabels()
            {
               gShowLabels = !gShowLabels;
               UpdateLabels(gShowLabels);
            }
            
            function UpdateLabels(bShow, bIgnoreSelection)
            {
               if(UpdateLabels.arguments.length < 2)
                  bIgnoreSelection = false;
               if(UpdateLabels.arguments.length < 1)
                  bShow = gShowLabels;
               
               if(bShow)
               {
                  EnsureLabelElementsCreated();
                  DisplayLabelElements(bIgnoreSelection)
               }
               else
               {
                  HideAllLabels();
               }
               gCurrentlyShowingLabels = bShow;
               document.getElementById("btnShowHideLabels").value = (bShow? "Hide" : "Show") + " Labels";
            }
            
            function EnsureLabelElementsCreated()
            {
               ForEachPoint
               (
                  function(series, seriesIdx, point, pointIdx)
                  {
                     if(!point.labelElement)
                     {
                        if(point.labelElement = document.createElement("span"))
                        {
                           point.labelElement.className = "LabelClass";
                           point.labelElement.innerHTML = GenerateLabelForPoint(series, point);
                           gProtectedChartDiv.appendChild(point.labelElement);
                        }
                     }
                  }
               );
            }
            
            function DestroyLabels()
            {
               gShowLabels = false;
               ForEachPoint
               (
                  function(series, seriesIdx, point, pointIdx)
                  {
                     if(point.labelElement && point.labelElement.parentNode)
                     {
                        point.labelElement.parentNode.removeChild(point.labelElement);
                     }
                     point.labelElement = null;
                  }
               );
            }
            
            function DisplayLabelElements(bIgnoreSelection)
            {
               var containerDivOffsets = CalculateOffsets(gProtectedChartDiv);
               ForEachPoint
               (
                  function(series, seriesIdx, point, pointIdx)
                  {
                     if(series.visible == false)
                     {
                        point.labelElement.style.visibility = "hidden";
                        return;
                     }
                     point.labelElement.style.visibility = "visible";
                     var pointCoordinates = null;
                     if(point != gChart.selected_point || bIgnoreSelection)
                     {
                        if(gChartType == kChartType_Pie)
                           pointCoordinates = series.findCenter(point);
                        else if(gChartType == kChartType_Bar)
                           pointCoordinates = GetCoordsForChartedBar(point, pointIdx, seriesIdx);
                     }
                     
                     if(pointCoordinates == null)
                     {
                        if(point.labelElement)
                           point.labelElement.style.visibility = "hidden";
                     }
                     else
                     {
                        if(gChartType == kChartType_Pie)
                        {
                           var left = pointCoordinates.x - Math.floor(point.labelElement.offsetWidth / 2) - containerDivOffsets.left;
                           var top = pointCoordinates.y - Math.floor(point.labelElement.offsetHeight / 2) - containerDivOffsets.top;
                           point.labelElement.style.left = FormatToPrecision(left, 0) + "px";
                           point.labelElement.style.top = FormatToPrecision(top, 0) + "px";
                        }
                        else
                           SetCoordsForBarLabel(point.labelElement, pointCoordinates, containerDivOffsets);
                     }
                  }
               );
            }
            
            function HideAllLabels()
            {
               ForEachPoint
               (
                  function(series, seriesIdx, point, pointIdx)
                  {
                     if(point.labelElement)
                        point.labelElement.style.visibility = "hidden";
                  }
               );
            }
            
            //for each point, calls doIt(series, seriesIndex, point, pointIndex)
            function ForEachPoint(doIt)
            {
               for(var i = 0; i < gCurrentChartedCols.length; ++i)
               {
                  var series = gCurrentChartedCols[i][1];
                  var points = series.getPoints();
                  for(var j = 0; j < points.length; ++j)
                  {
                     doIt(series, i, points[j], j);
                  }
               }
            }
            
            //shows or hides the chart legend
            function showHideLegend()
            {
               if(gChart)
               {
                  //EJSC_WORKAROUND
                  //the chart only lets us show/hide the legend at construction time!
                  //as a result, we will just hide/show it ourselves
                  if(gShowLegend)
                  {
                     gShowLegend = false;
                     gChart.__el_legend.style.display = "none";
                     document.getElementById("btnShowHideLegend").value = "Show Legend";
                  }
                  else
                  {
                     gChart.__el_legend.style.display = "block";
                     gShowLegend = true;
                     document.getElementById("btnShowHideLegend").value = "Hide Legend";
                  }
               }
            }
            
            //Sets all groups to collapsed or expanded
            //This is called by the 'Expand All' and 'Collapse All' buttons
            function SetAll(bCollapsing)
            {
               if(gGroupingIdxs.length > 0)
               {
                  var newDisplay = GetNewDisplay(bCollapsing);
                  var dataRowIdx = 0, groupingIdx = 0;
                  for(var rowsIdx = 0; rowsIdx < gRows.length; ++rowsIdx)
                  {
                     if(gGroupingIdxs[groupingIdx] == dataRowIdx)
                     {
                        if(HasChildGroup(groupingIdx) || gSecSortColIdx == 0)
                        {  //primary grouping row
                           SetRowImage(gRows[rowsIdx], bCollapsing);
                        }
                        else
                        {  //secondary grouping row
                           if(!bCollapsing)
                              SetRowImage(gRows[rowsIdx], bCollapsing);
                           gRows[rowsIdx].style.display = newDisplay;
                           if(bCollapsing)
                              SetRowImage(gRows[rowsIdx], bCollapsing);
                        }
                        ++groupingIdx;
                     }
                     else
                     {
                        ++dataRowIdx;
                        gRows[rowsIdx].style.display = newDisplay;
                     }
                  }
               }
            }
            
            //Extracts a label from something of the form "LABEL (n items)"
            function ExtractLabel(str)
            {
               return StripWhitespace(str.substr(0, str.lastIndexOf('(')));
            }
            
            //Attempt to strip all markup out of str
            //Basically tries to parse through the input string and be intelligent about possible cases like angle brackets in attribute strings
            //If the input is tricky or not well formed, this will fail
            function StripMarkup(str)
            {
               if(str == null)
                  return "";
               //we have to assume that our input is well-formed
               var outStr = "";
               var bInTag = false, bInString = false;
               var pos = 0, nextAppendPos = 0;
               var delim;
               while(pos < str.length)
               {
                  if(bInString)
                  {
                     if(str.charAt(pos) == '\\')
                     {
                        var ch = str.charAt(++pos);
                        if(ch == 'x' || ch == 'd')
                           pos += 3;
                        else if(ch == 'u')
                           pos += 5;
                        else
                           ++pos;
                     }
                     else if(str.charAt(pos) == delim)
                     {
                        ++pos;
                        bInString = false;
                     }
                     else
                        ++pos;
                  }
                  else if(str.charAt(pos) == '<')
                  {
                     bInTag = true;
                     outStr += str.substr(nextAppendPos, pos - nextAppendPos);
                     ++pos;
                  }
                  else if(bInTag && str.charAt(pos) == '>')
                  {
                     nextAppendPos = ++pos;
                     bInTag = false;
                  }
                  else if(bInTag && (str.charAt(pos) == '\'' || str.charAt(pos) == '\"'))
                  {
                     bInString = true;
                     delim = str.charAt(pos++);
                  }
                  else
                     ++pos;
               }
               return outStr + str.substr(nextAppendPos);
            }
            
            function StripWhitespace(str)
            {
               return str.replace(/^\s+/,"").replace(/\s+$/,"");
            }
            
            //Initialize does the following:
            // set up gRows to point to all grouping rows and data rows of the main report table
            // append "(N items)" to each grouping row label
            // initialize the controls associated with charting and construct the chart
            function Initialize()
            {
               doPreloadImages();
               if(gGroupingIdxs.length > 0)
               {
                  var rowsIdx = 0, rowParent = null, rows = null;
                  var row = document.getElementById("FirstGroupingRow");
                  if(row)
                  {
                     if(rowParent = row.parentNode)
                     {
                        if(rows = rowParent.getElementsByTagName("tr"))
                        {
                           
                           for(; rowsIdx < rows.length && rows[rowsIdx] != row; ++rowsIdx)
                              ;
                           var offset = rowsIdx;

                           var gRowsIdx = 0;
                           // Initialize gRows to point to the table's grouping rows and data rows
                           gRows = new Array(rows.length - offset);
                           for(; rowsIdx < rows.length && rows[rowsIdx].getAttribute("name") != "FooterRow"; ++rowsIdx)
                           {
                              if(rows[rowsIdx].parentNode == rowParent)
                                 gRows[gRowsIdx++] = rows[rowsIdx];
                              else
                                 gRows.pop();
                           }
                           for(; rowsIdx < rows.length; ++rowsIdx)
                              gRows.pop();

                           // Add a dummy entry to the grouping indices for the end
                           gGroupingIdxs.push(gRows.length - gGroupingIdxs.length);
                           
                           var itemCount = 0;
                           var rowIdx = gRows.length - 1;

                           for(var i = gGroupingIdxs.length - 2; i >= 0; --i)
                           {
                              var nCount = gGroupingIdxs[i+1] - gGroupingIdxs[i];
                              if(nCount == 0)
                              {
                                 nCount = itemCount;
                                 itemCount = 0;
                              }
                              else
                              {
                                 itemCount += nCount;
                                 rowIdx -= nCount;
                              }
                              var spans = gRows[rowIdx].getElementsByTagName("span");
                              spans[0].innerHTML += " (" + nCount.toString() + " item" + (nCount == 1 ? ")" : "s)");
                              --rowIdx;
                           }
                           
                           if(kOddBGColor != "")
                           {
                              rowIdx = 0;
                              for(var i = 0; i + 1 < gGroupingIdxs.length; ++i)
                              {
                                 if(gGroupingIdxs[i + 1] != gGroupingIdxs[i])
                                 {
                                    ++rowIdx;
                                    var nCount = gGroupingIdxs[i + 1] - gGroupingIdxs[i];
                                    for(var j = 1; j < nCount; j += 2)
                                    {
                                       gRows[rowIdx + j].style.backgroundColor = kOddBGColor;
                                    }
                                    rowIdx += nCount;
                                 }
                                 else
                                    ++rowIdx;//skip this grouping row
                              }
                           }
                           
                           var columnHeaderRow = document.getElementById("ColumnHeaderRow");
                           if(columnHeaderRow)
                           {
                              if(gPriSortColIdx != 0)
                              {
                                 kPrimarySortColLabel = StripWhitespace(GrabColumn(columnHeaderRow, 0));
                                 if(gSecSortColIdx != 0)
                                 {
                                    kSecondarySortColLabel = StripWhitespace(GrabColumn(columnHeaderRow, 1));
                                 }
                              }
                              
                              //initialize gSummableCols
                              for(var i = 0; i < gSummableCols.length; ++i)
                              {
                                 var theRealIdx = fakeColIdxToRealColIdx(gSummableCols[i][0]);
                                 gSummableCols[i][1] = StripWhitespace(GrabColumn(columnHeaderRow, theRealIdx));
                              }
                           }
                           
                           
                           var bDoCharting = gPriSortColIdx != 0;
                           
                           //Adjust gSummableCols indices to match the table
                           //Also, add columns to chart toolbar dropdown if necessary
                           var chartingColumnsDropdown = document.getElementById("h_ChartingColumnSelection");
                           if(bDoCharting)
                           {
                              document.getElementById("s_ChartingColumnSelection").options.add(new Option("Count", kColumn_Count, false, true))
                              chartingColumnsDropdown.options.add(new Option("Count", kColumn_Count, true, true));
                           }
                           else
                              document.getElementById("chartingDiv").style.display = "none";
                           for(var i = 0; i < gSummableCols.length; ++i)
                           {
                              var theRealIdx = fakeColIdxToRealColIdx(gSummableCols[i][0]);
                              if(bDoCharting)
                              {
                                 var strColumnLabel = gSummableCols[i][1];
                                 chartingColumnsDropdown.options.add(new Option(strColumnLabel, theRealIdx));
                              }
                              gSummableCols[i][0] = theRealIdx;
                           }
                           
                           if(bDoCharting)
                           {
                              //Set default images directory to match where our images are pulled from
                              var imagePath = "";
                              if(kBlankImageSrc.length > 9)//9 == strlen("blank.gif")
                                 imagePath = kBlankImageSrc.substr(0, kBlankImageSrc.length - 9);
                              EJSC.DefaultImagePath = imagePath;
                              //Initialize chart
                              MakeChart();
                              if(gChart)
                              {
                                 //zoom level, charted group index, and chart type all have valid values already
                                 //gCurrentlyChartedCols does not since no columns have been charted yet
                                 UpdateChart(gZoomLevel, gChartedGroupIdx, [kColumn_Count], gChartType);
                                 initDDList("ChartingColumnSelection");
                                 
                                 var divs = document.getElementsByTagName("div");
                                 for(var ii = 0; ii < divs.length; ++ii)
                                 {
                                    if(divs[ii].className == "ejschart")
                                    {
                                       gProtectedChartDiv = divs[ii];
                                    }
                                 }
                              }
                              else
                                 document.getElementById("chartingDiv").style.display = "none";
                           }
                           else
                              document.getElementById("chartingDiv").style.display = "none";
                        }
                     }
                  }
                  SumCols();
               }
               else
                  document.getElementById("chartingDiv").style.display = "none";
            }
            
            // This fixes the xslt issue with sums and floating point numbers that can't be exactly represented in IEEE format
            // Instead of letting the xslt sum the columns up for us, we will add them in javascript and format the numbers
            // before printing them to the table
            function SumCols()
            {
               if(gGroupingIdxs.length > 0)
               {
                  for(var i = 0; i < gSummableCols.length; ++i)
                  {
                     //index in the table of the column we are summing
                     var colIdx = gSummableCols[i][0];
                     //flags used to identify special cases of having numeric primary or secondary sort column
                     var bIsPrimarySortCol = (colIdx == 0 && gPriSortColIdx != 0);
                     var bIsSecondarySortCol = (colIdx == 1 && gSecSortColIdx != 0);
                     //current row in the table
                     var rowIdx = gRows.length - 1;
                     //priSum holds the sum for the current primary group, totalSum holds the sum for the whole table
                     var priSum = 0, totalSum = 0;
                     //bPriHasData is asserted if any row in a primary group has a value in the column
                     //bAnyHasData is asserted if any row has a value in the column
                     var bPriHasData = false, bAnyHasData = false;
                     //these are used to keep track of the max precision given to us
                     var primaryPrecision = 0, totalPrecision = 0;
                     // Go backwards so that whenever we encounter a group, we have already summed its children
                     for(var j = gGroupingIdxs.length - 2; j >= 0; --j)
                     {
                        if(HasChildGroup(j))
                        {
                           if(bIsPrimarySortCol)
                           {
                              //if we are summing the primary sort column, priSum is actually a count of the number of descendant data rows
                              var currentVal = ExtractLabel(GrabColumn(gRows[rowIdx], colIdx));
                              if(currentVal != "")
                              {
                                 totalPrecision = Math.max(totalPrecision, GetPrecision(currentVal));
                                 totalSum += priSum * ToNumber(currentVal);
                                 bAnyHasData = true;
                              }
                           }
                           else if(bPriHasData)
                           {
                              SetColumn(gRows[rowIdx], colIdx, FormatToPrecision(priSum, primaryPrecision));
                           }
                           --rowIdx;
                           priSum = 0;
                           primaryPrecision = 0;
                           bPriHasData = false;
                        }
                        else
                        {
                           var secSum = 0;
                           var bSeenSomething = false;
                           var secondaryPrecision = 0;
                           var childCount = gGroupingIdxs[j+1] - gGroupingIdxs[j];
                           if(bIsPrimarySortCol)
                           {
                              //if this is the primary sort column, we really only need to do (value in this group) * (# child rows in this group)
                              //we will count up the number of children in priSum, and then multiply when we actually set the value
                              rowIdx -= childCount;
                              priSum += childCount;
                              if(gSecSortColIdx == 0)
                              {
                                 var currentVal = ExtractLabel(GrabColumn(gRows[rowIdx], colIdx));
                                 if(currentVal != "")
                                 {
                                    totalSum += ToNumber(currentVal) * childCount;
                                    totalPrecision = Math.max(totalPrecision, GetPrecision(currentVal));
                                    bAnyHasData = true;
                                 }
                              }
                           }
                           else if(bIsSecondarySortCol)
                           {
                              rowIdx -= childCount;
                              var currentVal = ExtractLabel(GrabColumn(gRows[rowIdx], colIdx));
                              if(currentVal != "")
                              {
                                 secSum = childCount * ToNumber(currentVal);
                                 secondaryPrecision = GetPrecision(currentVal);
                                 primaryPrecision = Math.max(primaryPrecision, secondaryPrecision);
                                 totalPrecision = Math.max(totalPrecision, primaryPrecision);
                                 priSum += secSum;
                                 totalSum += secSum;
                                 bSeenSomething = true;
                                 bAnyHasData = true;
                                 bPriHasData = true;
                              }
                           }
                           else
                           {
                              //otherwise, for non-grouping columns we just need to sum the child data rows for this group
                              for(var k = 0; k < childCount; ++k)
                              {
                                 var currentVal = GrabColumn(gRows[rowIdx--], colIdx);
                                 if(currentVal != "")
                                 {
                                    secondaryPrecision = Math.max(secondaryPrecision, GetPrecision(currentVal));
                                    secSum += ToNumber(currentVal);
                                    bSeenSomething = true;
                                    bPriHasData = true;
                                    bAnyHasData = true;
                                 }
                              }
                              if(bSeenSomething)
                              {
                                 SetColumn(gRows[rowIdx], colIdx, FormatToPrecision(secSum, secondaryPrecision));
                              }
                              primaryPrecision = Math.max(primaryPrecision, secondaryPrecision);
                              totalPrecision = Math.max(totalPrecision, primaryPrecision);
                              priSum += secSum;
                              totalSum += secSum;
                           }
                           --rowIdx;
                        }
                     }
                     
                     if(bAnyHasData)
                     {
                        //if at least one row in the table had data, write the sum to the totals row
                        if(bIsPrimarySortCol && document.getElementById("FirstLabelSpan") != null)
                        {
                           document.getElementById("FirstLabelSpan").innerHTML = "Total " + FormatToPrecision(totalSum, totalPrecision);
                        }
                        else
                           SetColumn(document.getElementById("FooterTotalsRow"), colIdx, FormatToPrecision(totalSum, totalPrecision));
                     }

/*//This block will format all numbers in each numeric column to have the same number of digits after the decimal point.
//It increases the page load time significantly (~30% in initial tests)
                     if(!bIsPrimarySortCol && !bIsSecondarySortCol)
                     {
                        var r = 0;
                        for(var k = 0; k + 1 < gGroupingIdxs.length; ++k)
                        {
                           if(HasChildGroup(k))
                           {
                              var val = GrabColumn(gRows[r], colIdx);
                              if(val != "")
                              {
                                 gRows[r].getElementsByTagName("td")[colIdx].style.textAlign = "right";
                                 SetColumn(gRows[r], colIdx, FormatToPrecision(ToNumber(val), totalPrecision));
                              }
                              ++r;
                           }
                           else
                           {
                              var childCount = gGroupingIdxs[k + 1] - gGroupingIdxs[k];
                              for(var l = 0; l < childCount + 1; ++l)
                              {
                                 var val = GrabColumn(gRows[r], colIdx);
                                 if(val != "")
                                 {
                                    gRows[r].getElementsByTagName("td")[colIdx].style.textAlign = "right";
                                    SetColumn(gRows[r], colIdx, FormatToPrecision(ToNumber(val), totalPrecision));
                                 }
                                 ++r;
                              }
                           }
                        }
                     }
*/                     
                  }
               }
            }
            
            // Show or hide the report table and associated button row
            function ToggleReportVisibility(toggleBtnName)
            {
               var bChartShown = true;
               if(gChart == null)
               {
                  bChartShown = false;
               }
               else
                  bChartShown = document.getElementById("chartingDiv").style.display != "none";
                  
               var bShown = document.getElementById("ListReportDataTable").style.display != "none";
               if(bShown)
               {
                  document.getElementById("ListReportDataTable").style.display = "none";
                  document.getElementById("headerButtons").style.display = "none";
                  var buttons = document.getElementsByName("btnCollapseAll");
                  for(var i = 0; i < buttons.length; ++i)
                     buttons[i].style.visibility = "hidden";
                  buttons = document.getElementsByName("btnExpandAll");
                  for(var i = 0; i < buttons.length; ++i)
                     buttons[i].style.visibility = "hidden";
                  buttons = document.getElementsByName(toggleBtnName);
                  for(var i = 0; i < buttons.length; ++i)
                     buttons[i].value = "Show Report";
               }
               else
               {
                  if(document.all)
                  {
                     document.getElementById("ListReportDataTable").style.display = "block";
                     document.getElementById("headerButtons").style.display = "block";
                  }
                  else
                  {
                     document.getElementById("ListReportDataTable").style.display = "table";
                     document.getElementById("headerButtons").style.display = "table";
                  }
                     
                  var buttons = document.getElementsByName("btnCollapseAll");
                  for(var i = 0; i < buttons.length; ++i)
                     buttons[i].style.visibility = "visible";
                  buttons = document.getElementsByName("btnExpandAll");
                  for(var i = 0; i < buttons.length; ++i)
                     buttons[i].style.visibility = "visible";
                  buttons = document.getElementsByName(toggleBtnName);
                  for(var i = 0; i < buttons.length; ++i)
                     buttons[i].value = "Hide Report";
               }
               
            }
            
            //show/hide chart & associated controls
            function ToggleChartVisibility(toggleBtnName)
            {
               var bShown = true;
               if(gChart == null)
               {
                  bShown = false;
                  MakeChart();
               }
               else
                  bShown = document.getElementById("chartingDiv").style.display != "none";
                  
               if(bShown)
               {
                  document.getElementById("chartingDiv").style.display = "none";
                  var buttons = document.getElementsByName(toggleBtnName);
                  for(var i = 0; i < buttons.length; ++i)
                     buttons[i].value = "Show Chart";
               }
               else
               {
                  document.getElementById("chartingDiv").style.display = "block";
                  var buttons = document.getElementsByName(toggleBtnName);
                  for(var i = 0; i < buttons.length; ++i)
                     buttons[i].value = "Hide Chart";
               }
            }
            
            //This fires on the onchange event of h_ChartingColumnSelection
            //Essentially, we use this to ensure that the user does not try to chart 0 columns or chart >1 columns on a pie chart
            function ValidateColumnSelection()
            {
               var dropdown = document.getElementById("h_ChartingColumnSelection");
               var bCountsSelected = false, bNumericSelected = false, countsIdx = -1;
               var selectedCount = 0, firstSelected = -1;
               for(var i = 0; i < dropdown.options.length; ++i) // for every option in the list
               {
                  if (dropdown.options[i].selected === true) // if it's selected
                  {
                     ++selectedCount;
                     if(firstSelected == -1)
                        firstSelected = i;
                     if(dropdown.options[i].value == kColumn_Count)
                     {
                        bCountsSelected = true;
                        countsIdx = i;
                     }
                     else
                        bNumericSelected = true;
                  }
               }

               // We can't chart more than one column with a pie chart, so enable/disable based on this criteria
               var pieChartEnabled = gChartType == kChartType_Pie || selectedCount <= 1;
               document.getElementById("pieIconSpan").className = "containerTd pieImage" + (pieChartEnabled? "Enabled" : "Disabled") + "Container";
               document.getElementById("pieIconSpan").innerHTML = GenerateIconHTML(kChartType_Pie, pieChartEnabled? kEnabled : kDisabled);

               // If we are currently charting as a pie chart, don't allow the user to select more than one column to chart
               if(gChartType == kChartType_Pie && selectedCount > 1)
               {
                  for(var i = firstSelected + 1; i < dropdown.options.length; ++i)
                     dropdown.options[i].selected = false;
               }
               
               // If nothing is selected, select the first column
               if(selectedCount == 0 && dropdown.options.length > 0)
               {
                  dropdown.options[0].selected = true;
               }
            }

            //Is column with index=colIdx one that we can sum?
            function IsColSummable(colIdx)
            {
               for(var i = 0; i < gSummableCols.length; ++i)
               {
                  if(gSummableCols[i][0] == colIdx)
                     return true;
               }
               return false;
            }

            function Chart_AfterUnselectPoint()
            {
               //when a point is unselected, if labels were being shown, we need to show the label again (previously, it would've been hidden so that we can show the hint)
               if(gShowLabels)
                  UpdateLabels();
            }
            
            function isNumeric(str)
            {
               return new RegExp(/^-?\d+([.]\d+$)?/).test(str);
            }
            
            //gets coordinates to the center of the bar represented by point
            function GetCoordsForChartedBar(point, pointIdx/*0-based index to its parent series such that point == series.getPoints()[pointIdx]*/, seriesIdx)
            {
               if(gChartType != kChartType_Bar)
                  return null;
               if(gCurrentChartedCols.length < 1) //this should never happen, but prevent an exception
                  return null;
                  
               var limits = gChart.axis_bottom.getZoom();
               if(isNumeric(point.x) && point.x < limits.min)   //if point.x > limits.max, we don't care
               {
                  return null;
               }
               limits = gChart.axis_left.getZoom();
               //NOTE: if we can drilldown, we don't care if it fits on the y-axis or not because what we have is a sum
               if(gChart.axis_left.force_static_points == false && gChart.axis_left.__text_values.__count() < 1)
               {
                  if(point.y < limits.min || point.y > limits.max)
                     return null;
               }
               else
               {
                  if(pointIdx + 1 < limits.min || pointIdx + 1 > limits.max)
                     return null;
               }
               
               pointCoordinates = new Object();
               var temp = gChart.axis_bottom.pointToPixel(point.x, true);
               if(temp.outsideBounds)
                  pointCoordinates = null;
               else
               {
                  pointCoordinates.x = temp.point;
               
                  //EJSC_WORKAROUND
                  //There is what looks like a bug (or unsupported functionality) in EJSCharts related to text labels and pointToPixel()
                  //However, it appears to have undocumented functionality as follows:
                  //    The axis spans from 0.5 to (num labels) + .5
                  //    pointToPixel on this axis will take a value in this range and convert it to pixels along the axis
                  
                  //To further compound this, we may need to deal with multiple bars for a specific label (ie. multiple series are charted)
                  //There doesn't appear to be any way through the provided interface to get coordinates of different bars
                  //This is how ___barseries.__doDraw() calculates the bar width, so replicate it here to allow us to get the correct coordinates
                  gCurrentChartedCols[0][1].__calculateSharedProperties();
                  var barHeight = (gCurrentChartedCols[0][1].__barOffsetMax - gCurrentChartedCols[0][1].__barOffsetMin) / (gChart["axis_" + gCurrentChartedCols[0][1].y_axis]).__scale;

                  //We will calculate the coordinates like this:
                  // 1. Find the center of the N bars for this label
                  // 2. Find the min for the bars (we know that we are exactly halfway through the drawing space for these bars
                  // 3. Calculate the coordinates for the bar that we want since we know seriesIdx
                  //FURTHER NOTE: 
                  // I assume this is due to something I'm doing, but when we have a report with only one sort column and we zoom into that group, the values are 0-based and not 1-based
                  var middle = gChart.axis_left.pointToPixel(pointIdx + 1);
                  if(!HasChildGroup(0) && !CanDrilldown(gZoomLevel))
                     middle = gChart.axis_left.pointToPixel(pointIdx);
                  var min = middle + (VisibleSeriesCount() / 2.0 * barHeight);
                  //adjust for hidden series
                  for(var i = seriesIdx - 1; i >= 0; --i)
                  {
                     if(gCurrentChartedCols[i][1].visible == false)
                        --seriesIdx;
                  }
                  pointCoordinates.y = min - (seriesIdx + 0.5) * barHeight;
               }
               
               if(isNaN(pointCoordinates.x) || isNaN(pointCoordinates.y))
                  pointCoordinates = null;
               if(pointCoordinates != null)
               {
                  var zeroX = gChart.axis_bottom.pointToPixel(0);
                  pointCoordinates.x = zeroX + (pointCoordinates.x - zeroX) / 2;
               }
               
               return pointCoordinates;
            }
            
            function VisibleSeriesCount()
            {
               var visibleSeries = 0;
               for(var i = 0; i < gCurrentChartedCols.length; ++i)
               {
                  if(gCurrentChartedCols[i][1].visible)
                     ++visibleSeries;
               }
               return visibleSeries;
            }
            
            function Chart_AfterSelectPoint(point, series, chart, hint_element, hoverOrSelect)
            {
               if(gShowLabels)
               {
                  UpdateLabels();
               }
            }

            //Sets the coordinates for the label div for a particular data point over its corresponding bar
            function SetCoordsForBarLabel(labelDiv, coords, containerDivOffsets)
            {
               if(SetCoordsForBarLabel.arguments.length < 3)
                  containerDivOffsets = {left: 0, top: 0};
               var l = coords.x - Math.floor(labelDiv.offsetWidth / 2);
               var t = coords.y - Math.floor(labelDiv.offsetHeight / 2);
               if(gChartType == kChartType_Bar)
               {
                  var limits = gChart.axis_bottom.getZoom();
                  var minx = gChart.axis_bottom.pointToPixel(limits.min, true).point + 4;//ejs charts seems to add 4 pixels of padding
                  var maxx = gChart.axis_bottom.pointToPixel(limits.max, true).point;
                  //for bar charts, we need to check our limits
                  if(l < minx)
                     l = minx;
                  else if(l + labelDiv.offsetWidth > maxx)
                     l = maxx - labelDiv.offsetWidth;
               }
               t -= containerDivOffsets.top;
               l -= containerDivOffsets.left;
               labelDiv.style.left = FormatToPrecision(l, 0) + "px";
               labelDiv.style.top = FormatToPrecision(t, 0) + "px";
            }
            
            //construct the chart
            //gChart is supposed to be a singleton, so only the first call to MakeChart should actually do anything
            function MakeChart()
            {
               if(gChart == null)
               {
                  gChart = new EJSC.Chart('ejsChartDiv', 
                     {title: "",
                      show_titlebar: false,
                      axis_bottom: {caption: "", crosshair: {show: true}, label_class: "AxisLabelClass", stagger_ticks: false, size: kBottomAxisLabelsSize },
                      axis_left: {caption: "", crosshair: {show: true}, label_class: "AxisLabelClass", size: kLeftAxisLabelsSize, force_static_points: true },
                      allow_mouse_wheel_zoom: false,
                      show_legend: gShowLegend,
                      onDblClickPoint: Chart_DoubleClick,
                      onAfterUnselectPoint: Chart_AfterUnselectPoint,
                      onAfterSelectPoint: Chart_AfterSelectPoint,
                      onAfterZoom: Chart_AfterZoom
                     }
                  );
                  if(gChart)
                  {
                     //EJSC_Workaround
                     //Hide the 'owner' image on the legend
                     if(gChart.__el_legend_owner)
                     {
                        var divs = gChart.__el_legend_owner.getElementsByTagName("div");
                        for(var i = 0; i < divs.length; ++i)
                        {
                           if(divs[i].className == "ejsc-legend-owner-icon")
                              divs[i].style.visibility = "hidden";
                        }
                     }
                  }
               }
            }
            
            //Gets an array of the indices of the columns that are currently charted
            //This is used when we are updating the chart without changing what columns are charted (eg. drilldown or change chart type)
            function CurrentChartedColumns_NoSeries()
            {
               var columns = new Array(gCurrentChartedCols.length);
               for(var i = 0; i < gCurrentChartedCols.length; ++i)
                  columns[i] = gCurrentChartedCols[i][0];
               return columns;
            }
            
            // Assumes that we've already checked whether or not we actually can drilldown (see CanDrilldown())
            function DrilldownChart(groupingIdx /*Index to gGroupingIdxs*/)
            {
               switch(gZoomLevel)
               {
                  case kZoomLevel_All:
                  {
                     UpdateChart(kZoomLevel_Primary, groupingIdx, CurrentChartedColumns_NoSeries(), gChartType);
                  }
                  break;
                  
                  //Zoomed in on a primary group
                  case kZoomLevel_Primary:
                  {
                     UpdateChart(kZoomLevel_Secondary, groupingIdx, CurrentChartedColumns_NoSeries(), gChartType);
                  }
                  break;
               }
               gChart.axis_bottom.resetZoom();
               gChart.axis_left.resetZoom();
            }
            
            //Can we drilldown from where we currently are?
            function CanDrilldown(zoomLevel)
            {
               if(gGroupingIdxs.length == 0)
                  return false;
               else if(!HasChildGroup(0))
                  return zoomLevel == kZoomLevel_All;
               else
                  return zoomLevel != kZoomLevel_Secondary;
            }
            
            //callback for the chart's double-click event
            //Drills down if possible
            //return value is used by the chart to determine whether or not to continue other processing (ie. zoom out)
            //return false <==> don't zoom out;  return true <==> allow zoom out
            function Chart_DoubleClick(point, series, chart)
            {
               if(chart == gChart)
               {
                  // searchValue == what is the name of the group to drilldown on
                  var searchValue = point.x; // in most cases, this is the x-axis value
                  if(gChartType == kChartType_Bar) //since bar charts have labels on the y-axis, this is the y-axis value
                     searchValue = GetFullLabel(point, series);
                  else if(gChartType == kChartType_Pie)  //pie charts use the 'label' property instead of x or y
                     searchValue = point.label;
                  
                  //Before we attempt drilldown, ensure that we actually can drilldown
                  if(CanDrilldown(gZoomLevel))
                  {
                     switch(gZoomLevel)
                     {
                        //Zooming in on a specific primary group
                        case kZoomLevel_All:
                        {
                           //grab the labels for each primary group
                           var primaryLabels = ForEachPrimary
                           (
                              function(groupingIdx, groupRowsIdx, childGroupRows, descendantDataRows)
                              {
                                 return [groupingIdx, ExtractLabel(GrabColumn(gRows[groupRowsIdx], 0))];
                              }
                           );
                        
                           //Find the specific group to drilldown into and do it
                           for(var i = 0; i < primaryLabels.length; ++i)
                           {
                              if(primaryLabels[i][1] == searchValue) 
                              {
                                 DrilldownChart(primaryLabels[i][0]);
                                 return false;
                              }
                           }
                        }
                        break;
                        
                        //Zooming in on a specific secondary group
                        case kZoomLevel_Primary:
                        {
                           //grab the labels for each secondary group under this group
                           var secondaryLabels = ForEachSecondary
                           (
                              gChartedGroupIdx,
                              function(groupingIdx, groupRowsIdx, childDataRowCount)
                              {
                                 return [groupingIdx, ExtractLabel(GrabColumn(gRows[groupRowsIdx], 1))];
                              }
                           );
                           
                           //Find the specific group to drilldown into and do it
                           for(var i = 0; i < secondaryLabels.length; ++i)
                           {
                              if(secondaryLabels[i][1] == searchValue)
                              {
                                 DrilldownChart(secondaryLabels[i][0]);
                                 return false;
                              }
                           }
                        }
                        break;
                     }
                  }
                  else
                  {
                     // Double clicked, but we can't drilldown
                     // This isn't an error, but we might want to later do something here
                  }
               }
               
               //if we didn't drilldown, let them zoom out
               return true;
            }
            
            //Update whether the axes are shown
            function UpdateAxes()
            {
               if(gChart != null)
               {
                  var bShowYAxis = true;
                  var bShowXAxis = true;
                  //Set an absolute lower bound of 0 on the numeric axis - we can always zoom in if we don't like it
                  var axisToSetMinZero = null;
                  
                  // Assume all globals have already been updated (ie. the current chart state will not change until another event happens)
                  if(gChartType == kChartType_Bar)
                  {
                     bShowYAxis = CanDrilldown(gZoomLevel);
                     axisToSetMinZero = gChart.axis_bottom;
                  }
                  else if(gChartType == kChartType_Pie)
                  {
                     bShowYAxis = false;
                     bShowXAxis = false;
                  }
                  
                  if(axisToSetMinZero != null)
                  {
                     var extremes = axisToSetMinZero.getExtremes();
                     if(isNaN(extremes.min) || extremes.min > 0)
                     {
                        axisToSetMinZero.setExtremes(0, extremes.max);
                     }
                  }
                  
                  //This fixes an issue with axes not being hidden for pie charts
                  if(gChart.axis_left.visible != bShowYAxis)
                     gForceRedrawAxes = true;
                  if(gChart.axis_bottom.visible != bShowXAxis)
                     gForceRedrawAxes = true;

                  if(bShowYAxis)
                  {
                     gChart.axis_left.show();
                  }
                  else
                  {
                     gChart.axis_left.hide();
                  }

                  if(bShowXAxis)
                  {
                     gChart.axis_bottom.show();
                  }
                  else
                  {
                     gChart.axis_bottom.hide();
                  }
               }
            }
            
            var gDivForTextWidths = null, gSpanForTextWidths = null;
            function LabelTextMetrics(str)
            {
               if(gSpanForTextWidths == null)
               {
                  
                  gSpanForTextWidths = document.createElement("span");
                  gSpanForTextWidths.style.visibility = "hidden";
                  //EJSC_Workaround
                  //These style attributes should match what gets applied to the text we want the width of
                  //This method is intended to get the width of y-axis labels
                  //If the ejsc css changes in the future, this will need updated
                  gSpanForTextWidths.style.zIndex = "-1";
                  gSpanForTextWidths.style.fontSize = "10px";
                  gSpanForTextWidths.style.fontFamily = "Verdana";
                  
                  gDivForTextWidths = document.createElement("div");
                  gDivForTextWidths.style.visibility = "hidden";
                  gDivForTextWidths.style.zIndex = "-1";
                  gDivForTextWidths.style.position = "absolute";
                  gDivForTextWidths.style.left = "0px";
                  gDivForTextWidths.style.top = "0px";
                  gDivForTextWidths.style.width = kLeftAxisLabelsSize;
                  gDivForTextWidths.appendChild(gSpanForTextWidths);
                  document.getElementsByTagName("body")[0].appendChild(gDivForTextWidths);
               }
               
               gSpanForTextWidths.innerHTML = str;
               return {width: gSpanForTextWidths.offsetWidth, height: gSpanForTextWidths.offsetHeight};
            }

            
            //returns a string to be a hint for a specific series; uses text replacement (See EJSC Text replacement options)
            function GenerateHint(seriesType, strLabel, bAddDrilldownHint, bShowLabels, strActualLabel)
            {
               if(GenerateHint.arguments.length < 5)
                  strActualLabel = null;
               var strMouseoverHint = strLabel;
               switch(seriesType)
               {
                  case kChartType_Bar:
                     if(bShowLabels)
                     {
                        if(strActualLabel != null)
                        {
                           strMouseoverHint += "<br />" + strActualLabel;
                        }
                        else
                           strMouseoverHint += "<br />[y]";
                     }
                     strMouseoverHint += "<br />[x]";
                  break;
                  
                  case kChartType_Pie:
                     if(bShowLabels)
                        strMouseoverHint += "<br />[label]";
                     strMouseoverHint += "<br />[x] ([percent]%)";
                  break;
               }
               if(bAddDrilldownHint)
                  strMouseoverHint += "<br /><strong>Double-click to zoom in</strong>";
               return strMouseoverHint;
            }
            
            function GetFullLabel(point, series)
            {
               if(gChartType == kChartType_Pie)
               {
                  //we aren't truncating pie chart labels
                  return point.label;
               }
               
               var fullLabel = point.y;
               if(point.y.length >= kEllipsis.length && point.y.substr(point.y.length - kEllipsis.length) == kEllipsis)
               {
                  //if the label was truncated, grab the actual label
                  var points = series.getPoints();
                  for(var j = 0; j < gFullLabelArray.length; ++j)
                  {
                     if(gFullLabelArray[j][0] < points.length && points[gFullLabelArray[j][0]] == point)
                     {
                        fullLabel = gFullLabelArray[j][1];
                     }
                  }
               }
               
               return fullLabel;
            }
            
            //this is called whenever the hint is about to be displayed (usually due to mousing over a charted series)
            function OnShowHint(point, series, chart, strHint)
            {
               var bShowLabels = CanDrilldown(gZoomLevel);
               var bShowDrilldownHint = bShowLabels;
               var bFoundIt = false;
               var strActualLabel = GetFullLabel(point, series);
               return GenerateHint(gChartType, series.title, bShowDrilldownHint, bShowLabels, strActualLabel);
               
            }

            //callback for when a series is shown/hidden
            function Series_OnAfterVisibilityChange(series, chart, visible)
            {
               UpdateLabels();
            }
            
            //callback for when a series is shown/hidden
            function Series_OnBeforeVisibilityChange(series, chart, visible)
            {
               if(!visible)
               {
                  //EJSC_WORKAROUND
                  //The user will get a javascript error and will see 'Undefined' show up on their screen if they select a point and then hide that series
                  //As a workaround, unselect
                  var points = series.getPoints();
                  for(var i = 0; i < points.length; ++i)
                  {
                     if(points[i] == gChart.selected_point)
                     {
                        gChart.clearSelectedPoint();
                        break;
                     }
                  }
               }
            }
            
            //after the user zooms in or out on the chart, force reshowing the labels
            function Chart_AfterZoom(chart)
            {
               if(chart == gChart)
               {
                  if(gShowLabels)
                     UpdateLabels();
               }
            }
            
            //Adds a series to the chart given an array in the form [[label, data], [label, data], ...]
            function AddSeriesFromArray(dataArray, strLabel, bAddDrilldownHint, bNeedToShowLabels, bTreeLegend)
            {
               if(AddSeriesFromArray.arguments.length < 5)
                  bTreeLegend = gChartType == kChartType_Pie;
               if(AddSeriesFromArray.arguments.length < 4)
                  bNeedToShowLabels = false;
               var dataSeries = null;
               if(dataArray)
               {
                  if(gChart == null)
                     MakeChart();
                  
                  var strMouseoverHint = GenerateHint(gChartType, strLabel, bAddDrilldownHint, bAddDrilldownHint);
                  
                  //For bar charts and pie charts, we need to transform the data from [label, data] pairs to [data, label] pairs
                  var bSwapDataAndLabels = gChartType == kChartType_Bar || gChartType == kChartType_Pie;
                  if(bSwapDataAndLabels)
                  {
                     //swap x's & y's so it's horizontal
                     for(var i = 0; i < dataArray.length; ++i)
                     {
                        var temp = dataArray[i][0];
                        dataArray[i][0] = dataArray[i][1];
                        dataArray[i][1] = temp;
                     }
                  }
                  
                  //For bar charts, we need to reverse the order of the data so that it is charted in the same order that the report appears in
                  var bReverseDataOrder = gChartType == kChartType_Bar;
                  if(bReverseDataOrder)
                  {
                     for(var i = 0; i * 2 + 1 < dataArray.length; ++i)
                     {
                        var temp = dataArray[i];
                        dataArray[i] = dataArray[dataArray.length - i - 1];
                        dataArray[dataArray.length - i - 1] = temp;
                     }
                  }
                  
                  var dataHandler = new EJSC.ArrayDataHandler(dataArray);
                  
                  //Instantiate the correct series object to match the current chart type
                  if(gChartType == kChartType_Bar)
                  {
                     dataSeries = gChart.addSeries
                     (
                        new EJSC.BarSeries
                        (
                           dataHandler, 
                           {
                              padding: {y_axis_min: 0, y_axis_max: kBarSeriesPadding}, 
                              title: strLabel, 
                              treeLegend: bTreeLegend,
                              intervalOffset: kBarIntervalOffset, 
                              orientation: "horizontal", 
                              hint_string: strMouseoverHint, 
                              onShowHint: OnShowHint, 
                              onAfterVisibilityChange: Series_OnAfterVisibilityChange, 
                              onBeforeVisibilityChange: Series_OnBeforeVisibilityChange, 
                              onAfterDataAvailable: function() {gShowLabels = bNeedToShowLabels; UpdateLabels(); UpdateLegend(); this.onAfterDataAvailable = undefined;}
                           }
                        ), 
                        false /*no redraw*/
                     );
                  }
                  else if(gChartType == kChartType_Pie)
                  {
                     dataSeries = gChart.addSeries
                     (
                        new EJSC.PieSeries
                        (
                           dataHandler, 
                           {
                              title: strLabel, 
                              treeLegend: bTreeLegend, 
                              hint_string: strMouseoverHint, 
                              onShowHint: OnShowHint, 
                              onAfterVisibilityChange: Series_OnAfterVisibilityChange, 
                              onBeforeVisibilityChange: Series_OnBeforeVisibilityChange, 
                              onAfterDataAvailable: function() {gShowLabels = bNeedToShowLabels; UpdateLabels(); UpdateLegend(); this.onAfterDataAvailable = undefined;}
                           }
                        ), 
                        false /*no redraw*/
                     );
                  }
               }
               
               return dataSeries;
            }

            //This takes an index of a column from the XML and returns the index in the actual html table that corresponds to this column
            //The index from the XML is called 'fake' because it could be shifted around depending on the sort columns that are chosen
            //NOTE: This also takes care of the fact that the XML indices were 1-based, whereas the html table indices are 0-based
            function fakeColIdxToRealColIdx(fakeIdx)
            {
               var colIdx = fakeIdx;
               
               if(fakeIdx <= 0)   //If this is some special column, just preserve the index
                  return fakeIdx;
               else if(fakeIdx == gPriSortColIdx)  //If this is the primary sort column, it's now the first column
                  colIdx = 1;
               else if(fakeIdx == gSecSortColIdx)  //If this is the secondary sort column, it's now the second column
                  colIdx = 2;
               else if(colIdx < Math.max(gPriSortColIdx, gSecSortColIdx))  // Otherwise, if this previously came before the primary/secondary sort columns, it has been shifted 1 or 2 to the right
               {
                  if(colIdx < Math.min(gPriSortColIdx, gSecSortColIdx))
                     ++colIdx;
                  ++colIdx;
               }
               return colIdx - 1;
            }
            
            //Gets the label for column at index colIdx
            //NOTE: This ONLY works for numeric columns (counts included).
            function GetColumnLabel(colIdx)
            {
               if(colIdx == kColumn_Count)
                  return "Count";
               for(var i = 0; i < gSummableCols.length; ++i)
                  if(gSummableCols[i][0] == colIdx)
                     return gSummableCols[i][1];
               return "";
            }
            
            //Removes all current series on the chart and updates the chart type
            function PrepareToAddChartSeries(newChartType)
            {
               //Remove all current series in the chart
               for(var i = 0; i < gCurrentChartedCols.length; ++i)
               {
                  gChart.removeSeries(/*this is a pointer to the charted series*/ gCurrentChartedCols[i][1], /*redraw = */false);
               }
               
               gChartType = newChartType;
               gCurrentChartedCols = new Array();
            }
            
            function CalculateOffsets(element)
            {
               var offsets = {left: 0, top: 0};
               for(; element != null; element = element.offsetParent)
               {
                  offsets.left += element.offsetLeft;
                  offsets.top += element.offsetTop;
               }
               return offsets;
            }

            //This is the main function that changes the chart
            //newZoomLevel is the data context (either all primary groups, single primary group, or single secondary group)
            //newChartedGroupIdx is the index of the group to chart or kChartedGroup_None if we aren't charting a particular group
            //newChartedColIdxs are the indices of the columns to chart; kColumn_Count is also a valid index
            //newChartType is what type the chart will be (bar or pie)
            function UpdateChart(newZoomLevel, newChartedGroupIdx/*valid entries = [0..gGroupingIdxs.length-1] U {kChartedGroup_None}*/, newChartedColIdxs/*valid entries = {col indices} U {kColumn_Count}*/, newChartType/*valid entries = {kChartType_*}*/)
            {
               // Can't do a pie chart with >1 series
               if(newChartedColIdxs.length > 1 && newChartType == kChartType_Pie)
               {
                  //this should never happen, but we want to prevent it anyways
                  return;
               }
               
               var bNeedToShowLabels = false;
               var bFailed = false;
               for(var i = 0; i < newChartedColIdxs.length && !bFailed; ++i)
               {
                  var minDataSeriesLength = 2;//we only care if this becomes < 2, so 2 is a sufficient starting value
                  var thisColData = null;
                  
                  //get this column's data differently based on what the zoom level is
                  switch(newZoomLevel)
                  {
                     //Looking at all primary groups
                     case kZoomLevel_All:
                     {
                        //Grab data for each primary group
                        thisColData = ForEachPrimary
                        (
                           function(groupingIdx, groupRowsIdx, childGroupRows, descendantDataRows)
                           {
                              var thisGroupLabel = ExtractLabel(GrabColumn(gRows[groupRowsIdx], 0));
                              var thisGroupData = "";
                              
                              if(newChartedColIdxs[i] == kColumn_Count)
                              {
                                 thisGroupData = descendantDataRows.length;
                              }
                              else
                              {
                                 thisGroupData = GrabNumericColumn(gRows[groupRowsIdx], newChartedColIdxs[i], true);
                              }
                              return [thisGroupLabel, thisGroupData];
                           }
                        );
                     }
                     break;
                     
                     //Zooming in on a primary group
                     case kZoomLevel_Primary:
                     {
                        //Grab data for each secondary group
                        //If we have secondary groups, we will have to traverse each secondary group under this primary group
                        if(HasChildGroup(0))
                        {
                           var thisGroupRowIdx = GetRowsIndex(gGroupingIdxs[newChartedGroupIdx]) - 2;
                           thisColData = ForEachSecondary
                           (
                              newChartedGroupIdx /*index to gGroupingIdxs*/,
                              function(groupingIdx, groupRowIdx, childDataRowCount)
                              {
                                 var thisGroupLabel = ExtractLabel(GrabColumn(gRows[groupRowIdx], 1));
                                 var thisGroupData = "";
                                 
                                 if(newChartedColIdxs[i] == kColumn_Count)
                                 {
                                    thisGroupData = childDataRowCount;
                                 }
                                 else if(newChartedColIdxs[i] == 0 && gPriSortColIdx != 0)
                                 {
                                    //grab this from the parent row; multiply by size of group!
                                    thisGroupData = childDataRowCount * GrabNumericColumn(gRows[thisGroupRowIdx], newChartedColIdxs[i], true);
                                 }
                                 else
                                 {
                                    thisGroupData = GrabNumericColumn(gRows[groupRowIdx], newChartedColIdxs[i], true);
                                 }
                                 return [thisGroupLabel, thisGroupData];
                              }
                           );
                        }
                        else  //no secondary groups
                        {
                           //grab data from each child data row
                           thisColData = new Array();
                           var childDataRowCount = gGroupingIdxs[newChartedGroupIdx + 1] - gGroupingIdxs[newChartedGroupIdx];
                           var firstDataRowIdx = GetRowsIndex(gGroupingIdxs[newChartedGroupIdx]);
                           var priSortColValue = 0;
                           if(newChartedColIdxs[i] == 0 && gPriSortColIdx != 0)
                           {
                              priSortColValue = GrabNumericColumn(gRows[firstDataRowIdx - 1], newChartedColIdxs[i], true);
                           }
                           for(var j = 0; j < childDataRowCount; ++j)
                           {
                              if(newChartedColIdxs[i] == kColumn_Count)
                              {
                                 // Charting counts on individual items
                                 thisColData.push([j, 1]);
                              }
                              else if(newChartedColIdxs[i] == 0 && gPriSortColIdx != 0)
                              {
                                 //grab this from the parent row
                                 thisColData.push([j, priSortColValue]);
                              }
                              else
                              {
                                 var idx = firstDataRowIdx + j;
                                 thisColData.push([j, GrabNumericColumn(gRows[idx], newChartedColIdxs[i])]);
                              }
                           }
                        }
                        
                     }
                     break;
                     
                     // Zooming in on all data rows in a secondary group
                     case kZoomLevel_Secondary:
                     {
                        var parentPrimaryRowIdx = 0;
                        var bFoundParentRow = false;
                        for(var j = newChartedGroupIdx - 1; j >= 0 && !bFoundParentRow; --j)
                        {
                           if(HasChildGroup(j))
                           {
                              parentPrimaryRowIdx = GetRowsIndex(gGroupingIdxs[j]) - 2;
                              bFoundParentRow = true;
                           }
                        }
                        
                        var childDataRowCount = gGroupingIdxs[newChartedGroupIdx + 1] - gGroupingIdxs[newChartedGroupIdx];
                        var firstDataRowIdx = GetRowsIndex(gGroupingIdxs[newChartedGroupIdx]);
                        
                        //if we are grabbing the primary or secondary sort column's value, get it up front instead of fetching it for each data row
                        var thisColSavedValue = 0;
                        if(newChartedColIdxs[i] == 0 && gPriSortColIdx != 0)
                        {
                           thisColSavedValue = GrabNumericColumn(gRows[parentPrimaryRowIdx], newChartedColIdxs[i], true);
                        }
                        else if(newChartedColIdxs[i] == 1 && gSecSortColIdx != 0)
                        {
                           thisColSavedValue = GrabNumericColumn(gRows[firstDataRowIdx - 1], newChartedColIdxs[i], true);
                        }
                        
                        thisColData = new Array();
                        for(var j = 0; j < childDataRowCount; ++j)
                        {
                           // Use j+1 for the label instead of just j
                           if(newChartedColIdxs[i] == kColumn_Count)
                           {
                              // Charting counts on individual items
                              thisColData.push([j + 1, 1]);
                           }
                           else if((newChartedColIdxs[i] == 0 && gPriSortColIdx != 0) || (newChartedColIdxs[i] == 1 && gSecSortColIdx != 0))
                           {
                              //this value is on the parent row, not the data row
                              //we should've already filled 'thisColSavedValue' with the necessary value
                              thisColData.push([j + 1, thisColSavedValue]);
                           }
                           else
                           {
                              var idx = firstDataRowIdx + j;
                              thisColData.push([j + 1, GrabNumericColumn(gRows[idx], newChartedColIdxs[i])]);
                           }
                        }
                        
                     }
                     break;
                  }
                  
                  if(newChartType == kChartType_Pie)
                  {
                     var indicesToRemove = new Array();
                     //if this is a pie chart, remove data points with value 0 since they won't show up
                     for(var j = 0; j < thisColData.length; ++j)
                     {
                        if(thisColData[j][1] == 0)
                        {
                           indicesToRemove.push(j);
                        }
                     }
                     var idx = 0;
                     for(var j = 0; j < thisColData.length; ++j)
                     {
                        if(j == indicesToRemove[idx])
                        {
                           ++idx;
                        }
                        else
                        {
                           thisColData[j - idx] = thisColData[j];
                        }
                     }
                     for(; idx > 0; --idx)
                        thisColData.pop();
                  }

                  //if we removed all points (ie. all data points had value zero), we can't chart it!
                  if(!bFailed)
                     bFailed =  thisColData.length == 0;

                  if(!bFailed)
                  {
                     if(i == 0)
                     {
                        //This shouldn't happen, but we nonetheless want to prevent it from occurring
                        bNeedToShowLabels = gShowLabels;
                        DestroyLabels();
                        //NOTE: This updates gChartType
                        PrepareToAddChartSeries(newChartType);
                     }
                     
                     minDataSeriesLength = Math.min(minDataSeriesLength, thisColData.length);
                     
                     var fullLabelArray = null;
                     
                     if(newChartType == kChartType_Bar)
                     {
                        //For bar charts, axis labels may overlap each other
                        //Truncate them as necessary to keep each label from going past the vertical space alloted to its corresponding bar
                        var groupHeight = CalculateGroupHeight(thisColData.length);
                        var bGenerateFullLabelArray = i == 0;
                        fullLabelArray = AdjustLabelsForBarChart(thisColData, groupHeight, bGenerateFullLabelArray);
                     }
                     
                     //Shove data into a series
                     //Note: we pass bNeedToShowLabels in on the last series to be added to show the labels if necessary
                     var series = AddSeriesFromArray(thisColData, 
                        GetColumnLabel(newChartedColIdxs[i]), 
                        CanDrilldown(newZoomLevel),
                        i + 1 == newChartedColIdxs.length && bNeedToShowLabels,
                        CanDrilldown(newZoomLevel) && newChartType == kChartType_Pie);
                     
                     if(i == 0)
                     {
                        if(fullLabelArray != null)
                           gFullLabelArray = fullLabelArray;
                        else
                           gFullLabelArray = new Array();
                     }
                     
                     if(series)
                     {
                        gCurrentChartedCols.push([newChartedColIdxs[i], series]);
                     }
                  }
               }//foreach col

               if(!bFailed)
               {
                  //Update globals so that the state of the chart is accurately kept
                  gZoomLevel = newZoomLevel;
                  gChartedGroupIdx = newChartedGroupIdx;
                  //gCurrentChartedCols has already been updated
                  //Update the bread crumbs trail
                  UpdateChartingContext();
                  //Show/hide axes
                  UpdateAxes();
                  
                  //If this is a bar chart, the default legend order is the reverse of the charted bar order, so reverse the legend
                  if(newChartType == kChartType_Bar)
                     ReverseLegend();

                  //Finally, redraw the chart
                  gChart.redraw();
                  if(gForceRedrawAxes)
                  {
                     //EJSC_WORKAROUND
                     //Axis.hide() is spotty
                     //We will force it to redraw the axes so that we actually can hide them
                     //What is actually done is that __chart.__draw_axes does some checks like:
                     //    		if (this.axis_left != undefined && (this.__hasYAxisSeries() || this.axis_left.__hasManualExtremes())) { this.axis_left.__draw(ctx); }
                     // We are going to make it redraw by forcing __hasXAxisSeries() and __hasYAxisSeries() to return true for this call to __draw_axes
                     var saveXAxisMethod = gChart.__hasXAxisSeries;
                     var saveYAxisMethod = gChart.__hasYAxisSeries;
                     gChart.__hasXAxisSeries = function() { return true; };
                     gChart.__hasYAxisSeries = function() { return true; };
                     gChart.__draw_axes(gChart.__axes_context, true);
                     gChart.__hasXAxisSeries = saveXAxisMethod;
                     gChart.__hasYAxisSeries = saveYAxisMethod;
                     gForceRedrawAxes = false;
                  }
               }
            }
            
            function GrabCSSRule(selector)
            {
               if(document.styleSheets)
               {
                  for(var i = 0; i < document.styleSheets.length; ++i)
                  {
                     var ruleList = null;
                     if(document.styleSheets[i].cssRules)
                        ruleList = document.styleSheets[i].cssRules;
                     else if(document.styleSheets[i].rules)
                        ruleList = document.styleSheets[i].rules;
                     if(ruleList != null)
                     {
                        for(var j = 0; j < ruleList.length; ++j)
                        {
                           if(ruleList[j].selectorText == selector)
                           {
                              return ruleList[j];
                           }
                        }
                     }
                  }
               }
               return null;
            }
            
            var gDivForLegendWidth = null;
            function CheckLegendWidth(str)
            {
               if(gDivForLegendWidth == null)
               {
                  //EJSC_WORKAROUND
                  //We want to know the width of a legend element; however, this isn't possible to check through normal means
                  //because of element.style.overflow=="hidden"
                  //as a workaround, recreate the div hierarchy of the legend and 
                  var divClassHierarchy = [
                     "ejschart", 
                     "ejsc-legend ejsc-legend-maximized", 
                     "ejsc-legend-series", 
                     "ejsc-legend-series-div ejsc-legend-series-out",
                     "ejsc-legend-series-caption"];
                  var currentDiv = null;
                  for(var i = divClassHierarchy.length - 1; i >= 0; --i)
                  {
                     var nextDiv = document.createElement("div");
                     nextDiv.style.visibility = "hidden";
                     if(i > 0)
                        nextDiv.className = divClassHierarchy[i];
                     nextDiv.style.overflow = nextDiv.style.width = "auto";
                     if(currentDiv == null)
                        gDivForLegendWidth = nextDiv;
                     else
                        nextDiv.appendChild(currentDiv);
                     currentDiv = nextDiv;
                  }
                  currentDiv.style.position = "absolute";
                  currentDiv.style.left = "0px";
                  currentDiv.style.top = "0px";
                  currentDiv.style.zIndex = "-1";
                  document.getElementsByTagName("body")[0].appendChild(currentDiv);
               }
               gDivForLegendWidth.innerHTML = str;
               return {width: gDivForLegendWidth.offsetWidth, height: gDivForLegendWidth.offsetHeight};
            }
            
            //Traverse the subtree rooted at node el and find the max width of text elements (just checking properties won't work due to overflow css)
            //calls checkWidth to check the width of a string element
            //root is the root of the entire tree we are trying to search
            function CheckDescendantWidth(el, checkWidth, root)
            {
               var maxWidth = -1;
               if(el)
               {
                  if(el.childNodes)
                  {
                     if(el.childNodes.length > 0)
                     {
                        for(var i = 0; i < el.childNodes.length; ++i)
                        {
                           maxWidth = Math.max(maxWidth, CheckDescendantWidth(el.childNodes[i], checkWidth, root));
                        }
                     }
                     else if(el.nodeValue)
                     {
                        var curWidth = checkWidth(el.nodeValue).width;
                        var elem = el;
                        while(elem && !elem.offsetParent && elem != root)
                           elem = elem.parentNode;
                        while(elem && elem != root && elem.offsetParent != root.offsetParent)
                        {
                           curWidth += elem.offsetLeft;
                           elem = elem.offsetParent;
                        }
                        maxWidth = Math.max(maxWidth, curWidth);
                     }
                  }
               }
               return maxWidth;
            }
            
            function UpdateLegend()
            {
               var ejscLegendRule = GrabCSSRule(".ejsc-legend", legendHeight);
               var ejscSeriesContainerRule = GrabCSSRule(".ejsc-legend-series-container", containerHeight);
               if(ejscLegendRule != null && ejscSeriesContainerRule != null)
               {
                  ejscLegendRule.style.height = "auto";
                  ejscSeriesContainerRule.style.height = "auto";
                  //use its actual height only if it is within [100, 400]
                  var containerHeight = Math.min(400, Math.max(100, gChart.__el_legend_series.offsetHeight + 6));
                  var captionHeight = 16;
                  var captionRule = GrabCSSRule(".ejsc-legend-caption");
                  if(captionRule != null && captionRule.style.height.substr(captionRule.style.height.length - 2) == "px")
                     captionHeight = ToNumber(captionRule.style.height.substr(0, captionRule.style.height.length - 2));
                  var ownerHeight = 14;
                  var ownerRule = GrabCSSRule(".ejsc-legend-owner");
                  if(ownerRule != null && ownerRule.style.height.substr(ownerRule.style.height.length - 2) == "px")
                     ownerHeight = ToNumber(ownerRule.style.height.substr(0, ownerRule.style.height.length - 2));
                  var legendHeight = containerHeight + ownerHeight + captionHeight + 2;//add 2 for top & bottom borders on owner
                  ejscSeriesContainerRule.style.height = containerHeight;
                  ejscLegendRule.style.height = legendHeight;
                  ejscLegendRule.style.width = Math.max(240, 8 + CheckDescendantWidth(gChart.__el_legend_series, CheckLegendWidth, gChart.__el_legend_series));
                  //this fixes an IE issue on page load -- previously the legend didn't display any items
                  gChart.__el_legend.style.display = "block";
               }
            }
            
            function ReverseLegend()
            {
               //EJSC_WORKAROUND
               //When multiple columns are charted, the bars that appear on the chart go in reverse order of the entries in the legend
               //As a workaround, when we update the chart, reverse the order of the entries in the legend
               var seriesElement = gChart.__el_legend_series;
               var children = gChart.__el_legend_series.childNodes;
               for(var i = children.length - 1; i >= 0; --i)
               {
                  var element = children[i];
                  seriesElement.removeChild(element);
                  seriesElement.appendChild(element);
               }
            }
            
            function CalculateGroupHeight(numGroups)
            {
               if(numGroups < 1)
                  return 0;

               //EJSC_WORKAROUND
               //Usually, there are easier ways to get these numbers, but in most cases when we are updating the chart, these numbers seem to be undefined or stale
               //As a workaround, we will calculate these numbers ourselves
               var c_height = gChart.__el.offsetHeight - EJSC.utility.__borderSize(gChart.__el, "top") - EJSC.utility.__borderSize(gChart.__el, "bottom");
               var offsetBottom = gChart.axis_bottom.__getPhysicalSize();
               var heightAllottedToAxis = c_height - offsetBottom - kBarSeriesPadding;
               return heightAllottedToAxis / numGroups;
            }
            
            function AdjustLabelsForBarChart(dataArray, groupHeight, bGenerateFullLabelArray)
            {
               var fullLabelArray = null;
               if(bGenerateFullLabelArray)
                  fullLabelArray = new Array();
               
               //Check to see if all the labels are numbers
               //If so, the labels we pass are irrelevant, so don't worry about truncating them
               var bNonNumeric = false;
               for(var i = 0; i < dataArray.length && !bNonNumeric; ++i)
                  bNonNumeric = isNaN(parseFloat(dataArray[i][0]));
               
               if(bNonNumeric)
               {
                  //Each label has to be made to fit into a (kLeftAxisLabelsSize wide) by (groupHeight high) box
                  //Word wrap only happens on spaces, so the approach will be to add each word until the limit is hit
                  for(var i = 0; i < dataArray.length; ++i)
                  {
                     //dataArray[i][0] is the i-th label
                     var strNewLabel = "";
                     var words = dataArray[i][0].split(" ");
                     var bDone = false;
                     for(var j = 0; j < words.length && !bDone; ++j)
                     {
                        if(words[j].length == 0)
                        {
                           //if there were consecutive spaces, preserve them
                           strNewLabel += " ";
                        }
                        else
                        {
                           if(strNewLabel.length > 0)
                              strNewLabel += " ";
                           strNewLabel += words[j];
                           var metrics = LabelTextMetrics(strNewLabel);
                           if(metrics.height > groupHeight || metrics.width > kLeftAxisLabelsSize)
                           {
                              if(bGenerateFullLabelArray)
                              {
                                 //this label got truncated, so store its full label
                                 fullLabelArray.push([i, dataArray[i][0]]);
                              }
                              while(strNewLabel.length > 0 && !bDone)
                              {
                                 strNewLabel = strNewLabel.substr(0, strNewLabel.length - 1);
                                 metrics = LabelTextMetrics(strNewLabel + kEllipsis);
                                 bDone = metrics.height <= groupHeight && metrics.width < kLeftAxisLabelsSize;
                              }
                              
                              var match = -1;
                              for(var k = 0; k < i && match == -1; ++k)
                                 if(dataArray[k][0] == strNewLabel + kEllipsis)
                                    match = k;
                              
                              if(match != -1)
                              {
                                 /*const*/var kSeparator = "-";
                                 var countToMakeUnique = 2;
                                 bDone = false;
                                 while(strNewLabel.length > 0 && !bDone)
                                 {
                                    metrics = LabelTextMetrics(strNewLabel + kSeparator + countToMakeUnique + kEllipsis);
                                    bDone = metrics.height <= groupHeight && metrics.width < kLeftAxisLabelsSize;
                                    if(!bDone)
                                       strNewLabel = strNewLabel.substr(0, strNewLabel.length - 1);
                                 }
                                 strNewLabel += kSeparator;
                                 
                                 for(var k = match; k < i; ++k)
                                 {
                                    if(dataArray[k][0] == strNewLabel + countToMakeUnique + kEllipsis)
                                    {
                                       ++countToMakeUnique;
                                       bDone = false;
                                       while(strNewLabel.length > 0 && !bDone)
                                       {
                                          metrics = LabelTextMetrics(strNewLabel + countToMakeUnique + kEllipsis);
                                          bDone = metrics.height <= groupHeight && metrics.width < kLeftAxisLabelsSize;
                                          if(!bDone)
                                             strNewLabel = strNewLabel.substr(0, strNewLabel.length - 1);
                                       }
                                    }
                                 }
                                 strNewLabel += countToMakeUnique;
                              }
                              
                              strNewLabel += kEllipsis;
                              bDone = true;
                           }
                        }
                     }
                     dataArray[i][0] = strNewLabel;
                  }
               }
               return fullLabelArray;
            }
            
            //returns a string representing the given chart type
            function ChartTypeAsStr(chartType)
            {
               switch(chartType)
               {
                  case kChartType_Bar:
                     return "Bar Chart";
                  case kChartType_Pie:
                     return "Pie Chart";
               }
               //should never happen
               return "Unknown";
            }
            
            //generates html for the icon based on its type (used to get alt text) and enabling (add link/no link)
            function GenerateIconHTML(chartType, enabling)
            {
               if(enabling == kEnabled)
                  return "<a href=\"javascript:void(0);\" onclick=\"UpdateChartWithNewType(" + chartType + ");\"><img border=\"0\" class=\"chartToolbarIcon\" src=\"" + kBlankImageSrc + "\" alt=\"" + ChartTypeAsStr(chartType) + "\" title=\"" + ChartTypeAsStr(chartType) + "\"/></a>";
               else
                  return "<img border=\"0\" class=\"chartToolbarIcon\" src=\"" + kBlankImageSrc + "\" alt=\"" + ChartTypeAsStr(chartType) + "\" title=\"" + ChartTypeAsStr(chartType) + "\"/>";
            }

            //update the bread crumb trail
            function UpdateChartingContext()
            {
               var chartingContextDiv = document.getElementById("chartingContext");
               var titleDiv = document.getElementById("chartTitleDiv");
               var bEnableUp = true;
               if(gZoomLevel == kZoomLevel_All)
               {
                  titleDiv.innerHTML = kPrimarySortColLabel + ": All";
                  chartingContextDiv.innerHTML = "<strong>" + kPrimarySortColLabel + ": All</strong>";
                  bEnableUp = false;
               }
               else if(gZoomLevel == kZoomLevel_Primary)
               {
                  if(HasChildGroup(0))
                  {
                     var primaryLabel = ExtractLabel( GrabColumn(gRows[GetRowsIndex(gGroupingIdxs[gChartedGroupIdx]) - 2], 0) );
                     titleDiv.innerHTML = kPrimarySortColLabel + ": " + primaryLabel;
                     chartingContextDiv.innerHTML = "<a href=\"javascript:void(0);\" onclick=\"GoUp(false)\">" + kPrimarySortColLabel + ": All</a> &gt; <strong>" + 
                        kPrimarySortColLabel + ": " + primaryLabel + "</strong>";
                  }
                  else
                  {
                     var primaryLabel = ExtractLabel( GrabColumn(gRows[GetRowsIndex(gGroupingIdxs[gChartedGroupIdx]) - 1], 0) );
                     titleDiv.innerHTML = kPrimarySortColLabel + ": "  + primaryLabel;
                     chartingContextDiv.innerHTML = "<a href=\"javascript:void(0);\" onclick=\"GoUp(false)\">" + kPrimarySortColLabel + ": All</a> &gt; <strong>" + 
                        kPrimarySortColLabel + ": " + primaryLabel + "</strong>";
                  }
               }
               else if(gZoomLevel == kZoomLevel_Secondary)
               {
                  var parentIdx = gChartedGroupIdx - 1;
                  for(; parentIdx > 0 && !HasChildGroup(parentIdx); --parentIdx);
                  if(parentIdx >= 0)
                  {
                     var secondaryLabel = ExtractLabel( GrabColumn(gRows[GetRowsIndex(gGroupingIdxs[gChartedGroupIdx]) - 1], 1) );
                     titleDiv.innerHTML = kSecondarySortColLabel + ": " + secondaryLabel;
                     var parentIdx = gChartedGroupIdx - 1;
                     while(!HasChildGroup(parentIdx))
                        --parentIdx;
                     var primaryValueLabel = ExtractLabel( GrabColumn(gRows[GetRowsIndex(gGroupingIdxs[parentIdx]) - 2], 0) );
                     chartingContextDiv.innerHTML = "<a href='javascript:void(0);' onclick=\"GoUp(true)\">" + kPrimarySortColLabel + ": All</a> &gt; " + 
                     "<a href='javascript:void(0);' onclick=\"GoUp(false)\">" + kPrimarySortColLabel + ": " + primaryValueLabel + "</a> &gt; <strong>" + 
                     kSecondarySortColLabel + ": " + secondaryLabel + "</strong>";
                  }
               }
               
               if(bEnableUp)
               {
                  document.getElementById("goUpButton").className = "goUpButtonEnabled";
                  document.getElementById("goUpButton").disabled = false;
               }
               else
               {
                  document.getElementById("goUpButton").className = "goUpButtonDisabled";
                  document.getElementById("goUpButton").disabled = true;
               }
            }
            
            //moves up the current breadcrumb trail;
            //if bToTop==true, moves to the top; otherwise just moves up one level
            function GoUp(bToTop)
            {
               if(bToTop || gZoomLevel == kZoomLevel_Primary)
               {
                  UpdateChart(kZoomLevel_All, kChartedGroup_None, CurrentChartedColumns_NoSeries(), gChartType);
               }
               else if(gZoomLevel == kZoomLevel_Secondary)
               {
                  var parentIdx = gChartedGroupIdx - 1;
                  for(; parentIdx > 0 && !HasChildGroup(parentIdx); --parentIdx);
                  if(parentIdx >= 0)
                     UpdateChart(kZoomLevel_Primary, parentIdx, CurrentChartedColumns_NoSeries(), gChartType);
               }
            }
            
            // Returns the # of decimal places in the decimal representation of a number
            function GetPrecision(strNumber)
            {
               var idx = strNumber.lastIndexOf('.');
               if(idx >= 0)
                  return strNumber.length - idx - 1;
               else
                  return 0;   //No decimal point means no precision past integers
            }
            
            // Formats num to precision decimal places by rounding
            function FormatToPrecision(num, precision)
            {
               var strNumber = (num + Math.pow(10, -1*precision) / 2).toString();
               var idx = strNumber.lastIndexOf('.');
               if(idx == -1)
               {
                  //append 0's as necessary
                  if(precision > 0)
                  {
                     strNumber += '.';
                     for(var i = 0; i < precision; ++i)
                        strNumber += '0';
                  }
               }
               else
               {
                  var currentPrecision = strNumber.length - idx - 1;
                  if(currentPrecision > precision)
                  {
                     strNumber = strNumber.substr(0, strNumber.length - (currentPrecision - precision));
                  }
                  else
                  {
                     for(var i = currentPrecision; i < precision; ++i)
                        strNumber += '0';
                  }
               }
               
               if(strNumber.length > 0 && strNumber.charAt(strNumber.length - 1) == '.')
                  strNumber = strNumber.substr(0, strNumber.length - 1);
               if(strNumber == "")
                  strNumber = "0";
               return strNumber;
            }

            //essentially does row[colIdx] = newValue
            function SetColumn(row, colIdx, newValue)
            {
               if(row)
               {
                  var cells = row.getElementsByTagName("td");
                  if(cells)
                  {
                     var findIdx = 0;
                     for(var i = 0; i < cells.length; ++i)
                     {
                        if(cells[i].parentNode == row)
                        {
                           if(findIdx == colIdx)
                           {
                              cells[i].innerHTML = newValue;
                              return true;
                           }
                           ++findIdx;
                        }
                     }
                  }
               }
               return false;
            }

            //essentially return row[colIdx]
            function GrabColumn(row, colIdx)
            {
               if(row)
               {
                  var cells = row.getElementsByTagName("td");
                  if(cells)
                  {
                     var findIdx = 0;
                     for(var i = 0; i < cells.length; ++i)
                     {
                        if(cells[i].parentNode == row)
                        {
                           if(findIdx == colIdx)
                           {  //found it
                              if(cells[i].innerHTML == "&nbsp;")
                                 return "";
                              return StripMarkup(cells[i].innerHTML);
                           }
                           ++findIdx;
                        }
                     }
                  }
               }
               return null;
            }
            
            //essentially return static_cast<float>(n)
            function ToNumber(n)
            {
               var ret = parseFloat(n);
               if(isNaN(ret))
                  ret = 0;
               return ret;
            }
            
            //essentially return (float)(row[colIdx])
            function GrabNumericColumn(row, colIdx, bCouldBeLabel)
            {
               if(GrabNumericColumn.arguments.length < 3 || !bCouldBeLabel)
                  return ToNumber(GrabColumn(row, colIdx));

               var value = GrabColumn(row, colIdx);
               if(value.lastIndexOf('(') != -1)
                  value = ExtractLabel(value);
               return ToNumber(StripWhitespace(value));
            }
            
            //This is called when the column selection dropdown loses focus, so we potentially have a new set of columns to chart
            function UpdateChartBasedOnColumnSelection()
            {
               //I don't think this call is necessary, but it doesn't hurt to make sure that the selection is valid
               ValidateColumnSelection();
               var dropdown = document.getElementById("h_ChartingColumnSelection");
               var columnsSelected = new Array();
               for(var i = 0; i < dropdown.options.length; ++i) // for every option in the list
               {
                  if (dropdown.options[i].selected === true) // if it's selected, chart it
                  {
                     columnsSelected.push(dropdown.options[i].value);
                  }
               }
               UpdateChart(gZoomLevel, gChartedGroupIdx, columnsSelected, gChartType);
            }
            
            function ShouldShowLabelsOnChart(chartType)
            {
               return chartType == kChartType_Pie || chartType == kChartType_Bar;
            }
            
            //change the chart type
            function UpdateChartWithNewType(newType)
            {
               if(ShouldShowLabelsOnChart(newType))
               {
                  document.getElementById("btnShowHideLabels").style.visibility = "visible";
               }
               else if(ShouldShowLabelsOnChart(gChartType))
               {
                  document.getElementById("btnShowHideLabels").style.visibility = "hidden";
               }
               
               UpdateChart(gZoomLevel, gChartedGroupIdx, CurrentChartedColumns_NoSeries(), newType);
            }
            
            ////////////////////////////////////////////////////////
            //Globals
            //gGroupingIdxs[i] == the XML row index that the ith grouping row correponds to
            //if gGroupingIdxs[i] == gGroupingIdxs[i+1], then the ith grouping row is a primary grouping row and the (i+1)th grouping row is a secondary grouping row with parent i
            //else the ith grouping row does not have child grouping rows
            //if there are secondary grouping rows, then the parent of secondary grouping row with index i has index j such that:
            //    j < i,
            //    j is a primary grouping row, and 
            //    there does not exist any k such that j < k < i and k is a primary grouping row
            var gGroupingIdxs = new Array();
            //gRows points to the actual tr elements representing the grouping rows and data rows, in the order they appear on the page when all expanded
            var gRows = null;

               /*const*/ var kZoomLevel_All = 0;
               /*const*/ var kZoomLevel_Primary = 1;
               /*const*/ var kZoomLevel_Secondary = 2;
            //gZoomLevel is what context we are currently viewing (possible values are the immediately preceeding constants)
            var gZoomLevel = kZoomLevel_All;
            
               //These should be 0...n so they can be used for array indices
               /*const*/ var kChartType_Bar = 0;
               /*const*/ var kChartType_Pie = 1;
            //gChartType must be one of the immediately preceeding constants
            var gChartType = kChartType_Bar;

               //special value for when we are at kZoomLevel_All since in that case we aren't charting any particular group
               /*const*/ var kChartedGroup_None = -1;
            //gChartedGroupIdx is the index in gGroupingIdxs representing the current group being viewed; valid values are [0..gGroupingIdxs.length - 2] and kChartedGroup_None
            var gChartedGroupIdx = kChartedGroup_None;
            
            //pointer to the one and only chart
            var gChart = null;
            
            //gCurrentChartedCols is an array of [colIdx, pSeries] pairs of currently charted columns
            // colIdx = index in the table of the column
            // pSeries = pointer to the charted series
            var gCurrentChartedCols = new Array();
            
            //array of non-truncated labels
            var gFullLabelArray = new Array();
            
            //gSummableCols is an array of indices of the columns that are summable
            //NOTE: In Initialize(), these indices get transformed from 'fake' indices to indices that correspond to the data table
            var gSummableCols = new Array();
            /*const*/ var kDisabled = 0;
            /*const*/ var kEnabled = 1;
            //Used to represent group counts, since this doesn't correspond to any particular column in the table
            /*const*/ var kColumn_Count = -1;
            
            /*const*/ var kLeftAxisLabelsSize = 100;
            /*const*/ var kBottomAxisLabelsSize = 20;
            /*const*/ var kBarSeriesPadding = 5;
            /*const*/ var kBarIntervalOffset = .9;

            /*const*/ var kEllipsis = "...";

            var gCurrentlyShowingLabels = false;
            var gShowLabels = false;
            var gShowLegend = true;
            var gForceRedrawAxes = false;
            var gProtectedChartDiv = null;
            
            //This just holds references to Image objects used for preloading images.  It isn't referenced anywhere else
            var gPreloaded = new Array();
            ]]>
            
            
            
            <xsl:if test="SeapineReport/Report/DataRows/Row">
               <xsl:for-each select="SeapineReport/Report/DataRows/Row">
                  <xsl:call-template name="write-javascript-grouping-array"/>
                  <xsl:if test="(position()=1) and Col">
                     <xsl:for-each select="Col">
                        <xsl:call-template name="write-javascript-columns-array"/>
                     </xsl:for-each>
                  </xsl:if>
               </xsl:for-each>
            </xsl:if>
            <xsl:text disable-output-escaping="yes">
               var gPriSortColIdx = </xsl:text>
            <xsl:value-of select="$priSortColIdx"/>
            <xsl:text disable-output-escaping="yes">;</xsl:text>
            <xsl:text disable-output-escaping="yes">
               var gSecSortColIdx = </xsl:text>
            <xsl:value-of select="$secSortColIdx"/>
            <xsl:text disable-output-escaping="yes">;</xsl:text>
            <xsl:text disable-output-escaping="yes">
               var gColumnCount = </xsl:text>
            <xsl:choose>
               <xsl:when test="SeapineReport/Report/TableHeader/ColHeading">
                  <xsl:value-of select="count(SeapineReport/Report/TableHeader/ColHeading)"/>
               </xsl:when>
               <xsl:otherwise>
                  <xsl:text disable-output-escaping="yes">0</xsl:text>
               </xsl:otherwise>
            </xsl:choose>
            <xsl:text disable-output-escaping="yes">;</xsl:text>
            <xsl:text disable-output-escaping="yes">
               var kPrimarySortColLabel = "";</xsl:text>
            <xsl:text disable-output-escaping="yes">
               var kSecondarySortColLabel = "";</xsl:text>
            <xsl:text disable-output-escaping="yes">
            /*const*/ var kCollapsedImageSrc = "</xsl:text>
            <xsl:value-of select="external:get-server-image('plus.gif')" disable-output-escaping="yes"/>
            <xsl:text disable-output-escaping="yes">";</xsl:text>
            <xsl:text disable-output-escaping="yes">
            /*const*/ var kExpandedImageSrc = "</xsl:text>
            <xsl:value-of select="external:get-server-image('minus.gif')" disable-output-escaping="yes"/>
            <xsl:text disable-output-escaping="yes">";</xsl:text>
            <xsl:text disable-output-escaping="yes">
            /*const*/ var kMoveUpImageSrc = ["</xsl:text>
            <xsl:value-of select="external:get-server-image('moveup_d.png')" disable-output-escaping="yes"/>
            <xsl:text disable-output-escaping="yes">", "</xsl:text>
            <xsl:value-of select="external:get-server-image('moveup_e.png')" disable-output-escaping="yes"/>
            <xsl:text disable-output-escaping="yes">"];</xsl:text>
            <xsl:text disable-output-escaping="yes">
            /*const*/ var kBlankImageSrc = "</xsl:text>
            <xsl:value-of select="external:get-server-image('blank.gif')" disable-output-escaping="yes"/>
            <xsl:text disable-output-escaping="yes">";</xsl:text>
            <xsl:text disable-output-escaping="yes">
            /*const*/ var kOddBGColor = "</xsl:text>
            <xsl:value-of select="$AlternateRowColor" disable-output-escaping="yes"/>
            <xsl:text disable-output-escaping="yes">";</xsl:text>
            
            <!--Ensure that all necessary images are pre-loaded by the browser-->
            <!--Note that for Safari, it appears to be necessary to do this AND the img tags with display:none at the bottom of the page-->
            <xsl:text disable-output-escaping="yes">
               function doPreloadImages()
               {
                  var sources = [
                     &quot;</xsl:text><xsl:value-of select="external:get-server-image('images.gif')" disable-output-escaping="yes"/><xsl:text disable-output-escaping="yes">&quot;,
                     &quot;</xsl:text><xsl:value-of select="external:get-server-image('images_d.gif')" disable-output-escaping="yes"/><xsl:text disable-output-escaping="yes">&quot;,
                     &quot;</xsl:text><xsl:value-of select="external:get-server-image('minus.gif')" disable-output-escaping="yes"/><xsl:text disable-output-escaping="yes">&quot;,
                     &quot;</xsl:text><xsl:value-of select="external:get-server-image('moveup_e.png')" disable-output-escaping="yes"/><xsl:text disable-output-escaping="yes">&quot;,
                     &quot;</xsl:text><xsl:value-of select="external:get-server-image('moveup_d.png')" disable-output-escaping="yes"/><xsl:text disable-output-escaping="yes">&quot;
                  ];
                  for(var i = 0; i &lt; sources.length; ++i)
                  {
                     var imageObject = new Image();
                     imageObject.src = sources[i];
                     gPreloaded.push(imageObject);
                  }
               }
            </xsl:text>
            
         </script>
         </head>

         <body onload="Initialize();">
            <xsl:if test="SeapineReport">
					<xsl:for-each select="SeapineReport">

						<xsl:call-template name="pageheader"/>

                  <div class="chartContainerDivClass" id="chartingDiv">
                     <div class="chartToolbarDivClass" id="chartToolbarDiv">
                        <table cellspacing="0" cellpadding="0" border="0" class="chartToolbarTableClass"><tr>
                           <td class="chartToolbarFirstRowClass">
                              <span class="chartToolbarLabelClass">Data to chart:</span>
                              <!-- Multiselect Control -->
                              <span class="dd" style="visibility:hidden;position:absolute;white-space:nowrap" id="c_ChartingColumnSelection">i</span>
                              <input type="hidden" name="ChartingColumnSelection" id="ChartingColumnSelection"></input>
                              <select class="dd" onfocus="showDDList(this)" id="s_ChartingColumnSelection" size="1" notset="" ondblclick="showDDList(this,this)">
                              </select>
                              <select class="dd" id="h_ChartingColumnSelection" style="visibility:hidden;position:absolute;z-index:100;" size="3" multiple="multiple" onblur="hideDDList(this); UpdateChartBasedOnColumnSelection();" onfocus="loadDDList(this)" onchange="ValidateColumnSelection();">
                              </select>
                              <!-- End Multiselect Control -->
                           </td>
                           <td align="right" class="iconsTd">
                              <table style="display: inline;" cellspacing="0" cellpadding="0" border="0"><tr>
                                 <xsl:variable name="imageSrc" select="external:get-server-image('blank.gif')"/>
                                 <td id="barIconSpan" class="containerTd barImageEnabledContainer">
                                    <a href="javascript:void(0);" onclick="UpdateChartWithNewType(kChartType_Bar);">
                                       <xsl:text disable-output-escaping="yes">&lt;img class=&quot;chartToolbarIcon&quot; border=&quot;0&quot; src=&quot;</xsl:text>
                                       <xsl:value-of select="$imageSrc" disable-output-escaping="yes"/>
                                       <xsl:text disable-output-escaping="yes">&quot; alt=&quot;Bar Chart&quot; title=&quot;Bar Chart&quot;/&gt;</xsl:text>
                                    </a>
                                 </td>
                                 <td class="spacerTd">
                                    <xsl:call-template name="NonBreakingSpace"/>
                                 </td>
                                 <td id="pieIconSpan" class="containerTd pieImageEnabledContainer">
                                    <a href="javascript:void(0);" onclick="UpdateChartWithNewType(kChartType_Pie);">
                                       <xsl:text disable-output-escaping="yes">&lt;img class=&quot;chartToolbarIcon&quot; border=&quot;0&quot; src=&quot;</xsl:text>
                                       <xsl:value-of select="$imageSrc" disable-output-escaping="yes"/>
                                       <xsl:text disable-output-escaping="yes">&quot; alt=&quot;Pie Chart&quot; title=&quot;Pie Chart&quot;/&gt;</xsl:text>
                                    </a>
                                 </td>
                              </tr></table>
                           </td>
                           <td align="right" style="width: 230px;">
                              <input type="button" id="btnShowHideLabels" value="Show Labels" style="margin-right: 10px; width: 100px;" onclick="ToggleLabels();"/>
                              <input type="button" id="btnShowHideLegend" value="Hide Legend" style="width: 100px;" onclick="showHideLegend();" />
                           </td>
                        </tr></table>
                     </div>
                     <div class="breadcrumbDivClass" id="breadCrumbDiv">
                        <span class="breadcrumbSpanClass" id="chartingContext"></span>
                        <input type="button" title="Back" class="goUpButtonDisabled" id="goUpButton" onclick="GoUp(false);" disabled="disabled"/>
                     </div>
                     <div class="chartTitleClass" id="chartTitleDiv"></div>
                     <div id="ejsChartDiv" class="chartDivClass"></div>
                     
                     <!--Make sure all necessary images get pre-loaded by the browser -->
                     <!--Note that for Safari, it appears to be necessary to do this AND the javascript preloading-->
                     <xsl:text disable-output-escaping="yes">&lt;img src=&quot;</xsl:text>
                     <xsl:value-of select="external:get-server-image('images.gif')" disable-output-escaping="yes"/>
                     <xsl:text disable-output-escaping="yes">&quot; style=&quot;display: none;&quot;/&gt;</xsl:text>

                     <xsl:text disable-output-escaping="yes">&lt;img src=&quot;</xsl:text>
                     <xsl:value-of select="external:get-server-image('images_d.gif')" disable-output-escaping="yes"/>
                     <xsl:text disable-output-escaping="yes">&quot; style=&quot;display: none;&quot;/&gt;</xsl:text>
                     
                     <xsl:text disable-output-escaping="yes">&lt;img src=&quot;</xsl:text>
                     <xsl:value-of select="external:get-server-image('moveup_e.png')" disable-output-escaping="yes"/>
                     <xsl:text disable-output-escaping="yes">&quot; style=&quot;display: none;&quot;/&gt;</xsl:text>

                     <xsl:text disable-output-escaping="yes">&lt;img src=&quot;</xsl:text>
                     <xsl:value-of select="external:get-server-image('moveup_d.png')" disable-output-escaping="yes"/>
                     <xsl:text disable-output-escaping="yes">&quot; style=&quot;display: none;&quot;/&gt;</xsl:text>

                     <xsl:text disable-output-escaping="yes">&lt;img src=&quot;</xsl:text>
                     <xsl:value-of select="external:get-server-image('minus.gif')" disable-output-escaping="yes"/>
                     <xsl:text disable-output-escaping="yes">&quot; style=&quot;display: none;&quot;/&gt;</xsl:text>

                  </div>

                  <xsl:call-template name="ButtonsRow">
                     <xsl:with-param name="id" select="'headerButtons'"/>
                  </xsl:call-template>

						<xsl:call-template name="createtable"/>
						<xsl:call-template name="createcharts"/>
						<xsl:call-template name="pagefooter"/>
					</xsl:for-each>
				</xsl:if>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
